#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
extern int yyparse(void);
#define YYPREFIX "yy"
#line 2 "config_grammar.y"
/*******************************************************************
 * Grammar for configuration file
 * 
 * Licensed under a dual GPL/BSD license.  (See LICENSE file for more info.)
 *
 * File: config_grammar.y
 *
 * Authors: bdpayne@cs.umd.edu, npetroni@cs.umd.edu, Chris.Hessing@utah.edu
 *
 * $Id: config_grammar.y,v 1.12 2006/06/01 22:49:49 galimorerpg Exp $
 * $Date: 2006/06/01 22:49:49 $
 * $Log: config_grammar.y,v $
 * Revision 1.12  2006/06/01 22:49:49  galimorerpg
 * Converted all instances of u_char to uint8_t
 * Fixed a bad #include in the generic frame handler.
 *
 * Revision 1.11  2006/05/31 05:10:51  chessing
 * Beginnings of EAP-TTLS-EAP-MD5, and added internet draft for EAP-TTLS to doc/standards.
 *
 * Revision 1.10  2006/05/26 22:04:58  chessing
 * Fixed some memory access errors, and cleaned up some wext stuff that was causing issues with the madwifi driver in wext mode.
 *
 * Revision 1.9  2006/05/17 22:18:10  chessing
 * A couple of small changes to Xsupplicant, and some major changes to the GUI configuration/monitor tool.
 *
 * Revision 1.8  2006/05/13 05:56:44  chessing
 * Removed last pieces of code that relied on SIGALRM.  Active scan timeout is now configurable so that people that wish to hammer on their cards now have the option to do that. ;)
 *
 * Revision 1.7  2006/04/17 03:56:23  chessing
 * Added some support to enable/disable TNC support both via the configuration file, and via IPC.
 *
 * Revision 1.6  2006/03/08 00:16:04  chessing
 * Fixed EAP hints code to work correctly when the request ID packet is padded out with null bytes.  (Observed in Aruba APs.)  Some changes/fixes for the EAP-AKA module.
 *
 * Revision 1.5  2006/02/23 22:26:50  chessing
 * Fix for bug id #1415020.  'Building Xsupplicant 1.2.3 Fails on FC4'.
 *
 * Revision 1.4  2006/01/03 04:02:35  chessing
 * Added the ability to store the PEAP password in a hashed format.  (Basically, an MS-CHAPv1 hash.)  Also added an 'ntpwdhash' program to the tools directory that will convert a cleartext password in to a hash that can be copied to the configuration file.
 *
 * Revision 1.3  2005/11/10 04:56:54  chessing
 * Added patch from Ben Gardner to add support for setting a specific WEP key prior to attempting to associte.  (With a few slight modifications by me to make it fit in the current CVS code, and get it supported in config-parse.)  Added patch from Pekka Savola to fix some header ordering issues, and a potential buffer overflow.
 *
 * Revision 1.2  2005/10/26 18:56:12  chessing
 * Some build fixes and small updates.
 *
 * Revision 1.1  2005/10/17 00:15:55  chessing
 * Moved the config parsing routines out to a new library called libxsupconfig.a, so that it will be easier to create third-party tools that can easily parse a config.
 *
 * Revision 1.65  2005/10/14 02:26:17  shaftoe
 * - cleanup gcc 4 warnings
 * - (re)add support for a pid in the form of /var/run/xsupplicant.<iface>.pid
 *
 * -- Eric Evans <eevans@sym-link.com>
 *
 * Revision 1.64  2005/09/08 16:27:01  chessing
 * Some small updates to the new state machine code.  First attempt at an auto association mode.  (It mostly works. ;)
 *
 * Revision 1.63  2005/08/25 02:20:20  chessing
 * Some cleanup in xsup_debug.c, added the ability to wait for an interface to come up if it is down when Xsupplicant is started.  Roughed in the ability to choose between having Xsupplicant auto associate you, or allow you to set the ssid manually.  The stale key timer can now be set in the config file.  The association timeout can be set in the config file, and will also be used once the functionality is in place to attempt to guess the key settings needed for association, as well as the functionality to auto associate.
 *
 * Revision 1.62  2005/08/20 19:06:53  chessing
 * Patch from Carsten Grohmann to fix a few things in xsup_get_state.c.  Also added the ability to define an empty network clause, that will set the card in to encryption disabled mode.  From there, anything short of changing the SSID will be ignored by Xsupplicant.
 *
 * Revision 1.61  2005/08/18 03:19:04  chessing
 * Added the ability to define an SSID with static WEP keys.  When we switch to a network that has this type of configuration we will set the keys, and stop the various association timers.
 *
 * Revision 1.60  2005/08/12 03:34:06  chessing
 * Fix to the TLS implementation, should help avoid some of the weird 'block cipher pad' errors.  Also includes a partial implementation of the ability to use static WEP keys based on the SSID in use.
 *
 * Revision 1.59  2005/08/09 01:39:13  chessing
 * Cleaned out old commit notes from the released version.  Added a few small features including the ability to disable the friendly warnings that are spit out.  (Such as the warning that is displayed when keys aren't rotated after 10 minutes.)  We should also be able to start when the interface is down.  Last, but not least, we can handle empty network configs.  (This may be useful for situations where there isn't a good reason to have a default network defined.)
 *
 *******************************************************************/  
  
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
  
#include <profile.h>
#include "xsupconfig.h"
#include <xsup_err.h>
#include "xsup_debug.h"
#include "wpa.h"

#ifdef EAP_SIM_ENABLE
#include "winscard.h"
#endif

#ifdef USE_EFENCE
#include <efence.h>
#endif

#define CLEAN_EXIT cleanup_parse(); return XECONFIGPARSEFAIL

int yylex(void);  
int yyerror(char *err);

extern struct config_data *config_info;
extern int config_linenum;

extern int config_parse_debug;

struct config_data *tmp_config = NULL;

struct config_eap_tls *tmp_tls = NULL;
struct config_eap_md5 *tmp_md5 = NULL;
struct config_eap_ttls *tmp_ttls = NULL;
struct config_eap_leap *tmp_leap = NULL;
struct config_eap_mschapv2 *tmp_mschapv2 = NULL;
struct config_eap_peap *tmp_peap = NULL; 
struct config_eap_sim *tmp_sim = NULL;
struct config_eap_aka *tmp_aka = NULL;
struct config_wpa_psk *tmp_wpa_psk = NULL;
struct config_static_wep *tmp_static_wep = NULL;
struct config_static_wep *tmp_initial_wep = NULL;

struct config_pap *tmp_p2pap =NULL;
struct config_chap *tmp_p2chap = NULL;
struct config_mschap *tmp_p2mschap = NULL;
struct config_mschapv2 *tmp_p2mschapv2 = NULL;

struct config_network *tmp_network = NULL;



void set_current_tls() {
  if (tmp_tls == NULL) 
    initialize_config_eap_tls(&tmp_tls);
} 
void set_current_static_wep() {
  if (tmp_static_wep == NULL)
    initialize_config_static_wep(&tmp_static_wep);
}
void set_current_initial_wep() {
  if (tmp_initial_wep == NULL)
    initialize_config_static_wep(&tmp_initial_wep);
}
void set_current_md5() {
  if (tmp_md5 == NULL) 
    initialize_config_eap_md5(&tmp_md5);
} 
void set_current_ttls() {
  if (tmp_ttls == NULL) 
    initialize_config_eap_ttls(&tmp_ttls);
} 
void set_current_leap() {
  if (tmp_leap == NULL) 
    initialize_config_eap_leap(&tmp_leap);
} 
void set_current_mschapv2() {
  if (tmp_mschapv2 == NULL) 
    initialize_config_eap_mschapv2(&tmp_mschapv2);
} 
void set_current_peap() {
  if (tmp_peap == NULL) 
    initialize_config_eap_peap(&tmp_peap);
} 
void set_current_sim() {
  if (tmp_sim == NULL) 
    initialize_config_eap_sim(&tmp_sim);
} 

void set_current_aka() {
  if (tmp_aka == NULL)
    initialize_config_eap_aka(&tmp_aka);
}

void set_current_wpa_psk() {
  if (tmp_wpa_psk == NULL)
    initialize_config_wpa_psk(&tmp_wpa_psk);
}

void set_current_p2pap() {
  if (tmp_p2pap == NULL)
    initialize_config_pap(&tmp_p2pap);
}
void set_current_p2chap() {
  if (tmp_p2chap == NULL)
    initialize_config_chap(&tmp_p2chap);
}
void set_current_p2mschap() {
  if (tmp_p2mschap == NULL)
    initialize_config_mschap(&tmp_p2mschap);
}
void set_current_p2mschapv2() {
  if (tmp_p2mschapv2 == NULL)
    initialize_config_mschapv2(&tmp_p2mschapv2);
}

void set_current_config() {
  if (tmp_config == NULL) 
      initialize_config_data(&tmp_config);
} 

void set_current_globals() {
  set_current_config();
  if (!tmp_config->globals)
    initialize_config_globals(&(tmp_config->globals));
}   

void set_current_network() {
  if (tmp_network == NULL) 
    initialize_config_network(&tmp_network);
} 


void cleanup_parse()
{
  if (tmp_config)
    delete_config_data(&tmp_config);
  if (tmp_static_wep)
    delete_config_static_wep(&tmp_static_wep);
  if (tmp_initial_wep)
    delete_config_static_wep(&tmp_initial_wep);
  if (tmp_tls)
    delete_config_eap_tls(&tmp_tls);
  if (tmp_md5)
    delete_config_eap_md5(&tmp_md5);
  if (tmp_ttls)
    delete_config_eap_ttls(&tmp_ttls);
  if (tmp_leap)
    delete_config_eap_leap(&tmp_leap);
  if (tmp_mschapv2)
    delete_config_eap_mschapv2(&tmp_mschapv2);
  if (tmp_peap)
    delete_config_eap_peap(&tmp_peap);
  if (tmp_sim)
    delete_config_eap_sim(&tmp_sim);
  if (tmp_aka)
    delete_config_eap_aka(&tmp_aka);
  if (tmp_wpa_psk)
    delete_config_wpa_psk(&tmp_wpa_psk);
  if (tmp_p2pap)
    delete_config_pap(&tmp_p2pap);
  if (tmp_p2chap)
    delete_config_chap(&tmp_p2chap);
  if (tmp_p2mschap)
    delete_config_mschap(&tmp_p2mschap);
  if (tmp_p2mschapv2)
    delete_config_mschapv2(&tmp_p2mschapv2);
  if (tmp_network)
    delete_config_network(&tmp_network);
}



/* function to check if debug is on and if so print the message */
void parameter_debug(char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
#ifndef PARSE_DEBUG
  return;
#endif
  vprintf(fmt, ap);
  va_end(ap);
}

#line 263 "config_grammar.y"
typedef union {
        char    *str;
        int     num;
} YYSTYPE;
#line 278 "config_grammar.c"
#define TK_NETWORK_LIST 257
#define TK_DEFAULT_NETNAME 258
#define TK_GENSTR 259
#define TK_DEFAULT_INT 260
#define TK_LOGFILE 261
#define TK_LOG_FACILITY 262
#define TK_AUTH_PERIOD 263
#define TK_HELD_PERIOD 264
#define TK_MAX_STARTS 265
#define TK_STALE_KEY_TIMEOUT 266
#define TK_ALLMULTI 267
#define TK_IPC_GROUP 268
#define TK_DESTINATION 269
#define TK_BSSID 270
#define TK_MULTICAST 271
#define TK_SOURCE 272
#define TK_AUTO 273
#define TK_MANUAL 274
#define TK_ASSOCIATION 275
#define TK_ASSOC_TIMEOUT 276
#define TK_ROAMING 277
#define TK_FIRMWARE 278
#define TK_XSUPPLICANT 279
#define TK_PASSIVE_SCANNING 280
#define TK_PASSIVE_TIMEOUT 281
#define TK_SCAN_TIMEOUT 282
#define TK_USE_EAP_HINTS 283
#define TK_ALL 284
#define TK_FRIENDLY_WARNINGS 285
#define TK_TYPE 286
#define TK_ALLOW_TYPES 287
#define TK_FORCE_EAPOL_VER 288
#define TK_WIRELESS 289
#define TK_WIRED 290
#define TK_CONTROL_WIRELESS 291
#define TK_WPA_GROUP_CRYPT 292
#define TK_WPA_PAIRWISE_CRYPT 293
#define TK_WEP40 294
#define TK_TKIP 295
#define TK_WRAP 296
#define TK_CCMP 297
#define TK_WEP104 298
#define TK_ANY 299
#define TK_PRIORITY 300
#define TK_IDENTITY 301
#define TK_IDENTITY_VAL 302
#define TK_DEST_MAC 303
#define TK_MACADDRESS 304
#define TK_SSID 305
#define TK_SSID_VAL 306
#define TK_USE_TNC 307
#define TK_WPA_PSK 308
#define TK_WPA_PSK_KEY 309
#define TK_WPA_PSK_HEX_KEY 310
#define TK_EAP_TLS 311
#define TK_USER_CERT 312
#define TK_USER_KEY 313
#define TK_USER_KEY_PASS 314
#define TK_SESSION_RESUME 315
#define TK_CNCHECK 316
#define TK_CNEXACT 317
#define TK_ROOT_CERT 318
#define TK_ROOT_DIR 319
#define TK_CRL_DIR 320
#define TK_CHUNK_SIZE 321
#define TK_RANDOM_FILE 322
#define TK_EAP_MD5 323
#define TK_USERNAME 324
#define TK_USERNAME_VAL 325
#define TK_PASSWORD 326
#define TK_EAP_LEAP 327
#define TK_EAP_TTLS 328
#define TK_PHASE2_TYPE 329
#define TK_PAP 330
#define TK_CHAP 331
#define TK_MSCHAP 332
#define TK_MSCHAPV2 333
#define TK_EAP_MSCHAPV2 334
#define TK_MSCHAPV2_HASH_PWD 335
#define TK_IAS_QUIRK 336
#define TK_EAP_PEAP 337
#define TK_PEAPV1_PROPER_KEYING 338
#define TK_INNER_ID 339
#define TK_EAP_SIM 340
#define TK_EAP_AKA 341
#define TK_AUTO_REALM 342
#define TK_YES 343
#define TK_NO 344
#define TK_EAP_GTC 345
#define TK_EAP_OTP 346
#define TK_SMARTCARD 347
#define TK_ENGINE_ID 348
#define TK_OPENSC_SO_PATH 349
#define TK_KEYID 350
#define TK_STATIC_WEP 351
#define TK_INITIAL_WEP 352
#define TK_STATIC_KEY1 353
#define TK_STATIC_KEY2 354
#define TK_STATIC_KEY3 355
#define TK_STATIC_KEY4 356
#define TK_WEP_TX_KEY 357
#define TK_NUMBER 358
#define TK_UNQUOTED_STR 359
#define TK_PASS 360
#define TK_COMMAND 361
#define TK_QUOTED_STR 362
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    1,    1,    2,    2,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    5,
    5,    5,    5,    4,    4,    4,    4,    4,    4,    6,
    6,    6,    6,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,   10,    9,    9,    9,   12,   12,   12,
   12,   12,   13,   13,   13,   13,   13,   14,   18,   18,
   18,   15,   15,   15,   11,   11,   16,   17,   17,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
   19,   19,   31,   31,   31,   31,   31,   31,   31,   31,
   31,   31,   23,   23,   32,   32,   33,   33,   33,   33,
   33,   24,   24,   34,   34,   35,   35,   35,   35,   35,
   20,   20,   36,   36,   38,   39,   39,   40,   40,   40,
   40,   40,   37,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   21,   21,   41,   41,   42,   42,   42,   42,
   42,   42,   22,   22,   43,   43,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   45,   45,   45,   45,   45,   46,
   51,   51,   52,   52,   52,   52,   52,   52,   47,   53,
   53,   54,   54,   54,   54,   54,   54,   48,   55,   55,
   56,   56,   56,   56,   56,   56,   49,   57,   57,   58,
   58,   58,   58,   58,   58,   50,   25,   25,   59,   59,
   60,   60,   60,   60,   60,   60,   26,   26,   61,   61,
   62,   62,   62,   62,   62,   62,   62,   27,   27,   63,
   63,   64,   64,   64,   64,   64,   64,   64,   64,   64,
   64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
   64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
   64,   64,   64,   64,   64,   64,   65,   65,   67,   67,
   68,   68,   68,   68,   68,   66,   66,   66,   28,   28,
   69,   69,   70,   70,   70,   70,   70,   70,   70,   70,
   70,   29,   29,   71,   71,   72,   72,   72,   72,   72,
   72,   72,   72,   72,   30,   30,   73,   73,   74,   74,
   74,
};
short yylen[] = {                                         2,
    2,    1,    1,    1,    2,    1,    2,    1,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    1,    3,    1,    4,    4,    4,    3,    3,    3,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    3,    2,    1,    3,    3,    3,    3,
    3,    4,    3,    2,    1,    3,    3,    3,    3,    3,
    4,    3,    2,    1,    4,    2,    1,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    1,    4,    3,    2,    1,    3,    3,    3,    3,
    3,    3,    4,    3,    2,    1,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    1,    1,    1,    1,    1,    1,    4,
    2,    1,    3,    3,    3,    3,    3,    3,    4,    2,
    1,    3,    3,    3,    3,    3,    3,    4,    2,    1,
    3,    3,    3,    3,    3,    3,    4,    2,    1,    3,
    3,    3,    3,    3,    3,    1,    4,    3,    2,    1,
    3,    3,    3,    3,    3,    3,    4,    3,    2,    1,
    3,    3,    3,    3,    3,    3,    3,    4,    3,    2,
    1,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    1,    1,    3,    3,    3,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    4,    3,
    2,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    4,    3,    2,    1,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    4,    3,    2,    1,    3,    3,
    3,
};
short yydefred[] = {                                      0,
    4,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    6,    8,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    5,    7,    9,   51,   53,    0,   11,
   12,   29,   27,   28,   49,   37,   38,   39,   30,   31,
   40,   41,   42,   43,   45,   46,   47,   44,   48,   32,
   33,   34,   35,   36,   16,   17,   18,   19,   20,   21,
   25,   26,   22,   23,   24,   13,   14,   15,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   59,
    0,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,  100,  101,  102,  103,  104,  105,  106,
  107,  108,  109,  110,   57,    0,   58,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   55,   60,   61,   54,   56,   50,   52,   75,   76,   77,
   98,  113,  114,  116,  115,  117,  118,  119,  120,  121,
  122,    0,  112,   88,   89,   90,   91,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   74,   92,   94,
   93,   97,   95,   96,    0,    0,  356,    0,  358,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  142,
    0,  144,  172,    0,    0,  174,    0,  176,    0,    0,
  258,    0,  260,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  184,
  256,    0,  186,  214,  215,  216,  217,  218,  219,    0,
    0,    0,  268,    0,  270,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  279,  327,  326,  328,    0,  281,  315,  316,    0,
    0,    0,  330,    0,  332,    0,    0,    0,  343,    0,
  345,    0,    0,    0,    0,    0,  124,    0,  126,    0,
    0,    0,    0,    0,  133,    0,  135,    0,    0,    0,
  355,  357,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  141,  143,    0,    0,  173,  175,    0,    0,
  257,  259,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  183,  185,
    0,    0,    0,  267,  269,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  278,  280,    0,    0,    0,  329,  331,    0,    0,
    0,  342,  344,    0,    0,    0,    0,    0,  123,  125,
    0,    0,    0,    0,    0,  132,  134,  111,  359,  360,
  361,  153,  154,  155,  156,  159,  157,  158,  160,  161,
  162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
    0,    0,    0,    0,    0,  177,  178,  179,  181,  180,
  182,  261,  262,  263,  265,  264,  266,  187,  188,  189,
  190,  192,  191,  193,  203,  204,  205,  206,  207,  208,
  194,  195,  196,  197,  198,  199,  200,  201,  202,  213,
  209,  210,  211,  212,    0,    0,    0,  222,    0,    0,
    0,  231,    0,    0,    0,  240,    0,    0,    0,  249,
  271,  272,  273,  275,  274,  276,  277,  317,  322,  321,
  323,  325,  324,    0,  320,  282,  283,  284,  285,  286,
  287,  288,  290,  289,  291,  298,  299,  300,  307,  308,
  309,  292,  293,  294,  295,  296,  297,  306,  310,  311,
  312,  313,  314,  301,  302,  303,  304,  305,  333,  334,
  335,  337,  336,  338,  339,  340,  341,  346,  347,  348,
  350,  349,  351,  352,  353,  354,  127,  128,  129,  130,
  131,  136,  137,  138,  139,  140,    0,    0,    0,  145,
  146,    0,    0,  220,  221,    0,    0,  229,  230,    0,
    0,  238,  239,    0,    0,  247,  248,    0,  148,  149,
  150,  152,  151,  223,  224,  225,  227,  226,  228,  232,
  233,  234,  236,  235,  237,  241,  242,  243,  245,  244,
  246,  250,  251,  252,  254,  253,  255,  319,
};
short yydgoto[] = {                                      25,
   26,   27,   28,   29,   59,  121,  122,  123,  124,  125,
  126,  127,  128,  129,  130,  131,  132,  133,  192,  134,
  135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
  193,  318,  319,  326,  327,  231,  232,  233,  444,  445,
  237,  238,  262,  263,  264,  265,  266,  267,  268,  269,
  487,  488,  491,  492,  495,  496,  499,  500,  242,  243,
  274,  275,  296,  297,  298,  299,  514,  515,  304,  305,
  310,  311,  218,  219,
};
short yysindex[] = {                                   -200,
    0,  -36,  -26,  -21,  -17,  -13,   -2,   18,   23,   62,
   70,  105,  107,  141,  150,  156,  188,  213,  231,  239,
  250,  200,  217,  226,    0,  607, -321,    0,    0, -272,
 -227, -307, -178,  -25,    8,   10,   12, -173, -314,   17,
 -249, -260,  -79, -251, -312,   16,   32, -310, -225,    2,
   64,  126, -321,    0,    0,    0,    0,    0,  338,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  336,  342,
  350,  362,  369,  389,  391,  396,  398,  404,  357,  363,
  365,  374,  380,  385,  390,  392,  406,  416,  419,    0,
  182,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  244,    0,  300, -102, -271,
 -190,  163, -149,  144,  149,  169, -266,  242,  -24, -105,
 -122,  -74,  -39,  508, -123,  399, -118,  -71, -125, -120,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  504,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  488,  507,    0,  -83,    0,  514,
  515,  518,  519,  521,  522,  528,  529,  533,  474,    0,
  -99,    0,    0,  537,  538,    0,  -28,    0,  541,  544,
    0,  -27,    0,  545,  548,  549,  551,  552,  553,  554,
  555,  556,  557,  558,  559,  498,  499,  501,  502,    0,
    0,  530,    0,    0,    0,    0,    0,    0,    0,  565,
  568,  569,    0, -117,    0,  570,  571,  574,  575,  577,
  578,  584,  585,  589,  592,  593,  597,  599,  600,  601,
  604,    0,    0,    0,    0,  439,    0,    0,    0,  605,
  608,  609,    0,  -70,    0,  610,  611,  612,    0,  -51,
    0,  613,  614,  615,  616,  617,    0, -115,    0,  619,
  620,  621,  624,  626,    0, -110,    0, -158,  -35,  309,
    0,    0,  -18,   -1, -199,  -22,   24,   69,   73,  330,
   89, -277,    0,    0, -309, -188,    0,    0, -255, -182,
    0,    0,  117,  125,   40,   34,  332,   45,  142,  179,
  181,  331,  191,   15, -212, -202, -184, -151,    0,    0,
 -234,   96,  333,    0,    0, -245, -256,  195,  197,  102,
   37,  335,  128,  199,  201,  203,  337,  207,   51,   63,
  211,    0,    0, -233,  132,   65,    0,    0, -216,  136,
   77,    0,    0,  339,  340,  341,  343,  346,    0,    0,
  344,  347,  348,  361,  366,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  637,  638,  664,  602, -277,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  667,  668,  -20,    0,  669,  670,
  -12,    0,  671,  673,   -9,    0,  675,  680,   -8,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  698,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  384,  215,  148,    0,
    0, -214,  140,    0,    0, -210,  152,    0,    0, -205,
  158,    0,    0, -195,  166,    0,    0,   39,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  744,  745,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  746,    0,    0,    0,    0,    0,    1,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  356,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  622,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  479,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,  722,  723,  -10,    0,  280,  180,  187,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -160,    0,    0,    0,    0, -157,    0, -155,    0,    0,
  422,    0,  445,    0,  438,    0,  534,    0,  322,    0,
    0,  531,    0,  509,    0,    0,    0,    0,    0,    0,
    0,  282,    0,  279,    0,  277,    0,  275,    0,  539,
    0,  510,    0,  480,    0,    0,    0,  184,    0,  481,
    0,  473,    0,  572,
};
#define YYTABLESIZE 969
short yytable[] = {                                     317,
   10,  273,  230,  261,  325,  293,  303,  374,  294,  409,
  295,   56,   80,   81,  416,  446,   55,  178,  179,  217,
   75,   76,   77,   78,   30,  343,   85,   86,   71,   72,
   88,   89,   93,   94,   31,  209,   22,   23,  508,   32,
   24,  331,   55,   33,   73,  516,   90,   34,   95,  447,
  236,   62,  448,  309,  397,    1,    2,    3,   35,    4,
    5,    6,    7,    8,    9,   10,   11,   12,   13,  452,
  441,  442,  443,  402,   14,   15,   16,  509,   36,   17,
   18,   19,   20,   37,   21,  241,   57,  180,  510,   58,
  501,  549,  210,  181,  511,  211,  347,  351,   82,  512,
  513,  261,  517,  453,  584,  518,  454,   87,  558,   79,
  604,  485,  588,  486,  610,  592,  596,   96,   97,  616,
  182,  489,   38,  490,  502,  550,  120,  503,  551,  622,
   39,   60,  183,   98,   61,  293,  184,  185,  294,  493,
  295,  494,  559,  186,  605,  560,  187,  606,  611,  188,
  189,  612,  182,  617,  190,  191,  618,   22,   23,  426,
  427,   24,  428,  623,  183,   40,  624,   41,  184,  185,
  449,  450,  497,  451,  498,  186,  455,  456,  187,  457,
   63,  188,  189,   64,   69,   70,  190,  191,  145,  220,
  221,  222,  223,  195,  196,  224,  225,  226,  227,  228,
  270,   42,  271,  215,  216,  300,  270,  301,  271,  197,
   43,  272,  220,  221,  222,  223,   44,  272,  224,  225,
  226,  227,  228,  302,  229,  215,  216,  312,  313,  314,
  315,  316,  320,  321,  322,  323,  324,  312,  313,  314,
  315,  316,  320,  321,  322,  323,  324,  229,   45,  234,
  147,  235,  306,  300,  307,  301,  176,   10,   10,  177,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
  308,  302,  306,   46,  307,   10,   10,   10,   83,   84,
   10,   10,   10,   10,  239,   10,  240,   99,  100,  101,
  308,   47,  102,  103,  104,  234,  239,  235,  240,   48,
  172,  105,  106,  485,  107,  486,  171,  173,  108,  109,
   49,  489,  110,  490,  493,  497,  494,  498,  213,  214,
  429,  430,   50,  419,  111,  172,  420,  172,  112,  113,
  146,  148,  173,   65,  173,  114,  431,  480,  115,   51,
  422,  116,  117,  423,  481,  482,  483,  484,   52,   99,
  100,  101,  118,  119,  102,  103,  104,  424,   10,   10,
  425,  509,   10,  105,  106,   66,  107,   67,  174,   68,
  108,  109,  510,   91,  110,   74,  465,  466,  511,  526,
  527,  149,  432,  512,  513,  433,  111,  469,  470,   92,
  112,  113,  467,  541,  542,  528,  150,  114,  462,  463,
  115,  464,  151,  116,  117,  544,  545,  555,  556,  543,
  152,   99,  100,  101,  118,  119,  102,  103,  104,  564,
  565,  546,  153,  557,  175,  105,  106,  434,  107,  154,
  435,  436,  108,  109,  437,  566,  110,  198,  199,  200,
  201,  202,  203,  204,  205,  206,  207,  439,  111,  155,
  440,  156,  112,  113,  504,  505,  157,  506,  158,  114,
  523,  524,  115,  525,  159,  116,  117,   99,  100,  101,
  530,  531,  102,  103,  104,  458,  118,  119,  459,  160,
   99,  105,  106,  460,  107,  161,  461,  162,  108,  109,
  552,  553,  110,  554,  561,  562,  163,  563,  607,  608,
  471,  609,  164,  472,  111,  602,  603,  165,  112,  113,
  613,  614,  166,  615,  167,  114,  619,  620,  115,  621,
  194,  116,  117,  292,  625,  626,  208,  627,  168,   99,
  100,  101,  118,  119,  102,  103,  104,  473,  169,  475,
  474,  170,  476,  105,  106,  212,  107,  328,  329,  478,
  108,  109,  479,  519,  110,  521,  520,  532,  522,  534,
  533,  536,  535,  392,  537,  539,  111,  330,  540,  547,
  112,  113,  548,  600,  333,  334,  601,  114,  335,  336,
  115,  337,  338,  116,  117,   99,  100,  101,  339,  340,
  102,  103,  104,  341,  118,  119,  342,  345,  346,  105,
  106,  349,  107,  318,  350,  353,  108,  109,  354,  355,
  110,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  111,  367,  368,  371,  112,  113,  372,  373,
  376,  377,  260,  114,  378,  379,  115,  380,  381,  116,
  117,   99,   99,   99,  382,  383,   99,   99,   99,  384,
  118,  119,  385,  386,  369,   99,   99,  387,   99,  388,
  389,  390,   99,   99,  391,  394,   99,  421,  395,  396,
  399,  400,  401,  404,  405,  406,  407,  408,   99,  411,
  412,  413,   99,   99,  414,  276,  415,  438,  477,   99,
  468,  507,   99,  529,  538,   99,   99,  577,  578,  277,
  567,  568,  569,  571,  570,  572,   99,   99,  573,  574,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  111,  575,  576,  579,  276,  580,  582,  583,  586,
  587,  590,  114,  591,  289,  594,  290,  291,  116,  277,
  595,  598,  599,    2,    3,    1,  147,   53,   54,  418,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  111,  410,  417,  344,  318,  581,  348,  585,  589,
  370,  593,  114,  597,  289,  393,  290,  291,  116,  318,
  352,  628,  403,  375,  398,    0,    0,    0,    0,  332,
  318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
  318,  318,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  318,    0,  318,    0,  318,  318,  318,  244,
  245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
  111,    0,    0,    0,    0,    0,  255,  256,  257,  258,
  259,  244,  245,  246,  247,  248,  249,  250,  251,  252,
  253,  254,  111,    0,    0,    0,    0,    0,  255,  256,
  257,  258,  259,    2,    3,    0,    4,    5,    6,    7,
    8,    9,   10,   11,   12,   13,    0,    0,    0,    0,
    0,   14,   15,   16,    0,    0,   17,   18,   19,   20,
    0,   21,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   22,   23,    0,    0,   24,
};
short yycheck[] = {                                     125,
    0,  125,  125,  164,  125,  166,  125,  125,  166,  125,
  166,  284,  273,  274,  125,  325,   27,  289,  290,  125,
  270,  271,  272,  273,   61,  125,  278,  279,  343,  344,
  343,  344,  343,  344,   61,  302,  358,  359,  284,   61,
  362,  125,   53,   61,  359,  302,  359,   61,  359,  359,
  125,  359,  362,  125,  125,  256,  257,  258,   61,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  325,
  348,  349,  350,  125,  275,  276,  277,  323,   61,  280,
  281,  282,  283,   61,  285,  125,  359,  359,  334,  362,
  325,  325,  359,  284,  340,  362,  125,  125,  359,  345,
  346,  262,  359,  359,  125,  362,  362,  359,  325,  359,
  325,  324,  125,  326,  325,  125,  125,  343,  344,  325,
  311,  324,   61,  326,  359,  359,  125,  362,  362,  325,
   61,  359,  323,  359,  362,  296,  327,  328,  296,  324,
  296,  326,  359,  334,  359,  362,  337,  362,  359,  340,
  341,  362,  311,  359,  345,  346,  362,  358,  359,  359,
  360,  362,  362,  359,  323,   61,  362,   61,  327,  328,
  359,  360,  324,  362,  326,  334,  359,  360,  337,  362,
  359,  340,  341,  362,  358,  359,  345,  346,  125,  312,
  313,  314,  315,  343,  344,  318,  319,  320,  321,  322,
  324,   61,  326,  309,  310,  324,  324,  326,  326,  359,
   61,  335,  312,  313,  314,  315,   61,  335,  318,  319,
  320,  321,  322,  342,  347,  309,  310,  353,  354,  355,
  356,  357,  353,  354,  355,  356,  357,  353,  354,  355,
  356,  357,  353,  354,  355,  356,  357,  347,   61,  324,
  125,  326,  324,  324,  326,  326,  359,  257,  258,  362,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  342,  342,  324,   61,  326,  275,  276,  277,  358,  359,
  280,  281,  282,  283,  324,  285,  326,  286,  287,  288,
  342,   61,  291,  292,  293,  324,  324,  326,  326,   61,
  121,  300,  301,  324,  303,  326,  125,  121,  307,  308,
   61,  324,  311,  326,  324,  324,  326,  326,  343,  344,
  343,  344,  123,  359,  323,  146,  362,  148,  327,  328,
   51,   52,  146,  359,  148,  334,  359,  323,  337,  123,
  359,  340,  341,  362,  330,  331,  332,  333,  123,  286,
  287,  288,  351,  352,  291,  292,  293,  359,  358,  359,
  362,  323,  362,  300,  301,  358,  303,  358,  125,  358,
  307,  308,  334,  358,  311,  359,  343,  344,  340,  343,
  344,   44,  359,  345,  346,  362,  323,  343,  344,  358,
  327,  328,  359,  343,  344,  359,   61,  334,  359,  360,
  337,  362,   61,  340,  341,  343,  344,  343,  344,  359,
   61,  286,  287,  288,  351,  352,  291,  292,  293,  343,
  344,  359,   61,  359,  125,  300,  301,  359,  303,   61,
  362,  359,  307,  308,  362,  359,  311,  294,  295,  296,
  297,  298,  294,  295,  296,  297,  298,  359,  323,   61,
  362,   61,  327,  328,  359,  360,   61,  362,   61,  334,
  359,  360,  337,  362,   61,  340,  341,  286,  287,  288,
  343,  344,  291,  292,  293,  359,  351,  352,  362,  123,
  125,  300,  301,  359,  303,  123,  362,  123,  307,  308,
  359,  360,  311,  362,  359,  360,  123,  362,  359,  360,
  359,  362,  123,  362,  323,  358,  359,  123,  327,  328,
  359,  360,  123,  362,  123,  334,  359,  360,  337,  362,
  358,  340,  341,  125,  359,  360,  358,  362,  123,  286,
  287,  288,  351,  352,  291,  292,  293,  359,  123,  359,
  362,  123,  362,  300,  301,  304,  303,   44,   61,  359,
  307,  308,  362,  359,  311,  359,  362,  359,  362,  359,
  362,  359,  362,  125,  362,  359,  323,   61,  362,  359,
  327,  328,  362,  359,   61,   61,  362,  334,   61,   61,
  337,   61,   61,  340,  341,  286,  287,  288,   61,   61,
  291,  292,  293,   61,  351,  352,  123,   61,   61,  300,
  301,   61,  303,  125,   61,   61,  307,  308,   61,   61,
  311,   61,   61,   61,   61,   61,   61,   61,   61,   61,
  123,  123,  323,  123,  123,   61,  327,  328,   61,   61,
   61,   61,  125,  334,   61,   61,  337,   61,   61,  340,
  341,  286,  287,  288,   61,   61,  291,  292,  293,   61,
  351,  352,   61,   61,  125,  300,  301,   61,  303,   61,
   61,   61,  307,  308,   61,   61,  311,  359,   61,   61,
   61,   61,   61,   61,   61,   61,   61,   61,  323,   61,
   61,   61,  327,  328,   61,  287,   61,  358,  358,  334,
  359,  359,  337,  359,  358,  340,  341,   61,   61,  301,
  362,  362,  362,  358,  362,  362,  351,  352,  362,  362,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  362,  358,   61,  287,  125,   61,   61,   61,
   61,   61,  334,   61,  336,   61,  338,  339,  340,  301,
   61,   44,  359,    0,    0,    0,  125,   26,   26,  328,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  318,  326,  231,  287,  445,  237,  487,  491,
  262,  495,  334,  499,  336,  296,  338,  339,  340,  301,
  242,  598,  310,  274,  304,   -1,   -1,   -1,   -1,  218,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  334,   -1,  336,   -1,  338,  339,  340,  312,
  313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
  323,   -1,   -1,   -1,   -1,   -1,  329,  330,  331,  332,
  333,  312,  313,  314,  315,  316,  317,  318,  319,  320,
  321,  322,  323,   -1,   -1,   -1,   -1,   -1,  329,  330,
  331,  332,  333,  257,  258,   -1,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,   -1,   -1,   -1,   -1,
   -1,  275,  276,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  358,  359,   -1,   -1,  362,
};
#define YYFINAL 25
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 362
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'='",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TK_NETWORK_LIST",
"TK_DEFAULT_NETNAME","TK_GENSTR","TK_DEFAULT_INT","TK_LOGFILE",
"TK_LOG_FACILITY","TK_AUTH_PERIOD","TK_HELD_PERIOD","TK_MAX_STARTS",
"TK_STALE_KEY_TIMEOUT","TK_ALLMULTI","TK_IPC_GROUP","TK_DESTINATION","TK_BSSID",
"TK_MULTICAST","TK_SOURCE","TK_AUTO","TK_MANUAL","TK_ASSOCIATION",
"TK_ASSOC_TIMEOUT","TK_ROAMING","TK_FIRMWARE","TK_XSUPPLICANT",
"TK_PASSIVE_SCANNING","TK_PASSIVE_TIMEOUT","TK_SCAN_TIMEOUT","TK_USE_EAP_HINTS",
"TK_ALL","TK_FRIENDLY_WARNINGS","TK_TYPE","TK_ALLOW_TYPES","TK_FORCE_EAPOL_VER",
"TK_WIRELESS","TK_WIRED","TK_CONTROL_WIRELESS","TK_WPA_GROUP_CRYPT",
"TK_WPA_PAIRWISE_CRYPT","TK_WEP40","TK_TKIP","TK_WRAP","TK_CCMP","TK_WEP104",
"TK_ANY","TK_PRIORITY","TK_IDENTITY","TK_IDENTITY_VAL","TK_DEST_MAC",
"TK_MACADDRESS","TK_SSID","TK_SSID_VAL","TK_USE_TNC","TK_WPA_PSK",
"TK_WPA_PSK_KEY","TK_WPA_PSK_HEX_KEY","TK_EAP_TLS","TK_USER_CERT","TK_USER_KEY",
"TK_USER_KEY_PASS","TK_SESSION_RESUME","TK_CNCHECK","TK_CNEXACT","TK_ROOT_CERT",
"TK_ROOT_DIR","TK_CRL_DIR","TK_CHUNK_SIZE","TK_RANDOM_FILE","TK_EAP_MD5",
"TK_USERNAME","TK_USERNAME_VAL","TK_PASSWORD","TK_EAP_LEAP","TK_EAP_TTLS",
"TK_PHASE2_TYPE","TK_PAP","TK_CHAP","TK_MSCHAP","TK_MSCHAPV2","TK_EAP_MSCHAPV2",
"TK_MSCHAPV2_HASH_PWD","TK_IAS_QUIRK","TK_EAP_PEAP","TK_PEAPV1_PROPER_KEYING",
"TK_INNER_ID","TK_EAP_SIM","TK_EAP_AKA","TK_AUTO_REALM","TK_YES","TK_NO",
"TK_EAP_GTC","TK_EAP_OTP","TK_SMARTCARD","TK_ENGINE_ID","TK_OPENSC_SO_PATH",
"TK_KEYID","TK_STATIC_WEP","TK_INITIAL_WEP","TK_STATIC_KEY1","TK_STATIC_KEY2",
"TK_STATIC_KEY3","TK_STATIC_KEY4","TK_WEP_TX_KEY","TK_NUMBER","TK_UNQUOTED_STR",
"TK_PASS","TK_COMMAND","TK_QUOTED_STR",
};
char *yyrule[] = {
"$accept : configfile",
"configfile : global_section network_section",
"configfile : global_section",
"configfile : network_section",
"configfile : error",
"global_section : global_section global_statement",
"global_section : global_statement",
"network_section : network_section network_entry",
"network_section : network_entry",
"global_statement : TK_NETWORK_LIST '=' TK_ALL",
"global_statement : TK_NETWORK_LIST '=' network_list",
"global_statement : TK_DEFAULT_NETNAME '=' TK_UNQUOTED_STR",
"global_statement : TK_DEFAULT_NETNAME '=' TK_QUOTED_STR",
"global_statement : TK_FRIENDLY_WARNINGS '=' TK_YES",
"global_statement : TK_FRIENDLY_WARNINGS '=' TK_NO",
"global_statement : TK_FRIENDLY_WARNINGS '=' TK_UNQUOTED_STR",
"global_statement : TK_ROAMING '=' TK_FIRMWARE",
"global_statement : TK_ROAMING '=' TK_XSUPPLICANT",
"global_statement : TK_ROAMING '=' TK_UNQUOTED_STR",
"global_statement : TK_PASSIVE_SCANNING '=' TK_YES",
"global_statement : TK_PASSIVE_SCANNING '=' TK_NO",
"global_statement : TK_PASSIVE_SCANNING '=' TK_UNQUOTED_STR",
"global_statement : TK_USE_EAP_HINTS '=' TK_YES",
"global_statement : TK_USE_EAP_HINTS '=' TK_NO",
"global_statement : TK_USE_EAP_HINTS '=' TK_UNQUOTED_STR",
"global_statement : TK_PASSIVE_TIMEOUT '=' TK_NUMBER",
"global_statement : TK_SCAN_TIMEOUT '=' TK_NUMBER",
"global_statement : TK_LOGFILE '=' TK_UNQUOTED_STR",
"global_statement : TK_LOGFILE '=' TK_QUOTED_STR",
"global_statement : TK_DEFAULT_INT '=' TK_UNQUOTED_STR",
"global_statement : TK_STALE_KEY_TIMEOUT '=' TK_NUMBER",
"global_statement : TK_STALE_KEY_TIMEOUT '=' TK_UNQUOTED_STR",
"global_statement : TK_ASSOCIATION '=' TK_AUTO",
"global_statement : TK_ASSOCIATION '=' TK_MANUAL",
"global_statement : TK_ASSOCIATION '=' TK_UNQUOTED_STR",
"global_statement : TK_ASSOC_TIMEOUT '=' TK_NUMBER",
"global_statement : TK_ASSOC_TIMEOUT '=' TK_UNQUOTED_STR",
"global_statement : TK_AUTH_PERIOD '=' TK_NUMBER",
"global_statement : TK_HELD_PERIOD '=' TK_NUMBER",
"global_statement : TK_MAX_STARTS '=' TK_NUMBER",
"global_statement : TK_ALLMULTI '=' TK_YES",
"global_statement : TK_ALLMULTI '=' TK_NO",
"global_statement : TK_ALLMULTI '=' TK_UNQUOTED_STR",
"global_statement : TK_IPC_GROUP '=' TK_UNQUOTED_STR",
"global_statement : TK_DESTINATION '=' TK_AUTO",
"global_statement : TK_DESTINATION '=' TK_BSSID",
"global_statement : TK_DESTINATION '=' TK_MULTICAST",
"global_statement : TK_DESTINATION '=' TK_SOURCE",
"global_statement : TK_DESTINATION '=' TK_UNQUOTED_STR",
"global_statement : TK_LOG_FACILITY '=' TK_UNQUOTED_STR",
"network_list : network_list ',' TK_UNQUOTED_STR",
"network_list : TK_UNQUOTED_STR",
"network_list : network_list ',' TK_QUOTED_STR",
"network_list : TK_QUOTED_STR",
"network_entry : TK_UNQUOTED_STR '{' network_statements '}'",
"network_entry : TK_NUMBER '{' network_statements '}'",
"network_entry : TK_QUOTED_STR '{' network_statements '}'",
"network_entry : TK_UNQUOTED_STR '{' '}'",
"network_entry : TK_QUOTED_STR '{' '}'",
"network_entry : TK_NUMBER '{' '}'",
"network_statements : network_statements network_parameter",
"network_statements : network_statements eap_type_statement",
"network_statements : network_parameter",
"network_statements : eap_type_statement",
"network_parameter : network_type_parameter",
"network_parameter : network_priority",
"network_parameter : network_use_tnc",
"network_parameter : network_wpa_group_enc_type",
"network_parameter : network_wpa_pairwise_enc_type",
"network_parameter : network_force_eapol_ver",
"network_parameter : network_identity_parameter",
"network_parameter : network_dest_mac_parameter",
"network_parameter : network_allow_parameter",
"network_parameter : network_control_wireless",
"network_priority : TK_PRIORITY '=' TK_NUMBER",
"network_type_parameter : TK_TYPE '=' TK_WIRELESS",
"network_type_parameter : TK_TYPE '=' TK_WIRED",
"network_type_parameter : TK_TYPE '=' TK_UNQUOTED_STR",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_WEP40",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_TKIP",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_WRAP",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_CCMP",
"network_wpa_group_enc_type : TK_WPA_GROUP_CRYPT '=' TK_WEP104",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_WEP40",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_TKIP",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_WRAP",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_CCMP",
"network_wpa_pairwise_enc_type : TK_WPA_PAIRWISE_CRYPT '=' TK_WEP104",
"network_force_eapol_ver : TK_FORCE_EAPOL_VER '=' TK_NUMBER",
"network_control_wireless : TK_CONTROL_WIRELESS '=' TK_YES",
"network_control_wireless : TK_CONTROL_WIRELESS '=' TK_NO",
"network_control_wireless : TK_CONTROL_WIRELESS '=' TK_UNQUOTED_STR",
"network_identity_parameter : TK_IDENTITY '=' TK_IDENTITY_VAL",
"network_identity_parameter : TK_IDENTITY '=' TK_QUOTED_STR",
"network_identity_parameter : TK_IDENTITY '=' TK_UNQUOTED_STR",
"network_use_tnc : TK_USE_TNC '=' TK_YES",
"network_use_tnc : TK_USE_TNC '=' TK_NO",
"network_dest_mac_parameter : TK_DEST_MAC '=' TK_MACADDRESS",
"network_allow_parameter : TK_ALLOW_TYPES '=' TK_ALL",
"network_allow_parameter : TK_ALLOW_TYPES '=' eap_type_list",
"eap_type_statement : eap_tls_statement",
"eap_type_statement : eap_md5_statement",
"eap_type_statement : eap_ttls_statement",
"eap_type_statement : static_wep_statement",
"eap_type_statement : initial_wep_statement",
"eap_type_statement : eap_leap_statement",
"eap_type_statement : eap_mschapv2_statement",
"eap_type_statement : eap_peap_statement",
"eap_type_statement : eap_sim_statement",
"eap_type_statement : eap_aka_statement",
"eap_type_statement : wpa_psk_statement",
"eap_type_list : eap_type_list ',' eap_type",
"eap_type_list : eap_type",
"eap_type : TK_EAP_TLS",
"eap_type : TK_EAP_MD5",
"eap_type : TK_EAP_TTLS",
"eap_type : TK_EAP_LEAP",
"eap_type : TK_EAP_MSCHAPV2",
"eap_type : TK_EAP_PEAP",
"eap_type : TK_EAP_SIM",
"eap_type : TK_EAP_AKA",
"eap_type : TK_EAP_GTC",
"eap_type : TK_EAP_OTP",
"static_wep_statement : TK_STATIC_WEP '{' static_wep_params '}'",
"static_wep_statement : TK_STATIC_WEP '{' '}'",
"static_wep_params : static_wep_params static_wep_param",
"static_wep_params : static_wep_param",
"static_wep_param : TK_STATIC_KEY1 '=' TK_QUOTED_STR",
"static_wep_param : TK_STATIC_KEY2 '=' TK_QUOTED_STR",
"static_wep_param : TK_STATIC_KEY3 '=' TK_QUOTED_STR",
"static_wep_param : TK_STATIC_KEY4 '=' TK_QUOTED_STR",
"static_wep_param : TK_WEP_TX_KEY '=' TK_NUMBER",
"initial_wep_statement : TK_INITIAL_WEP '{' initial_wep_params '}'",
"initial_wep_statement : TK_INITIAL_WEP '{' '}'",
"initial_wep_params : initial_wep_params initial_wep_param",
"initial_wep_params : initial_wep_param",
"initial_wep_param : TK_STATIC_KEY1 '=' TK_QUOTED_STR",
"initial_wep_param : TK_STATIC_KEY2 '=' TK_QUOTED_STR",
"initial_wep_param : TK_STATIC_KEY3 '=' TK_QUOTED_STR",
"initial_wep_param : TK_STATIC_KEY4 '=' TK_QUOTED_STR",
"initial_wep_param : TK_WEP_TX_KEY '=' TK_NUMBER",
"eap_tls_statement : TK_EAP_TLS '{' eap_tls_params '}'",
"eap_tls_statement : TK_EAP_TLS '{' '}'",
"eap_tls_params : eap_tls_params eap_tls_param",
"eap_tls_params : eap_tls_param",
"smartcard_section : TK_SMARTCARD '{' smartcard_params '}'",
"smartcard_params : smartcard_param smartcard_params",
"smartcard_params : smartcard_param",
"smartcard_param : TK_ENGINE_ID '=' TK_UNQUOTED_STR",
"smartcard_param : TK_OPENSC_SO_PATH '=' TK_UNQUOTED_STR",
"smartcard_param : TK_OPENSC_SO_PATH '=' TK_QUOTED_STR",
"smartcard_param : TK_KEYID '=' TK_UNQUOTED_STR",
"smartcard_param : TK_KEYID '=' TK_NUMBER",
"eap_tls_param : TK_USER_CERT '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_USER_CERT '=' TK_QUOTED_STR",
"eap_tls_param : TK_USER_KEY '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_USER_KEY '=' TK_QUOTED_STR",
"eap_tls_param : TK_USER_KEY_PASS '=' TK_PASS",
"eap_tls_param : TK_USER_KEY_PASS '=' TK_QUOTED_STR",
"eap_tls_param : TK_USER_KEY_PASS '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_SESSION_RESUME '=' TK_YES",
"eap_tls_param : TK_SESSION_RESUME '=' TK_NO",
"eap_tls_param : TK_SESSION_RESUME '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_ROOT_CERT '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_ROOT_CERT '=' TK_QUOTED_STR",
"eap_tls_param : TK_ROOT_DIR '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_ROOT_DIR '=' TK_QUOTED_STR",
"eap_tls_param : TK_CRL_DIR '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_CRL_DIR '=' TK_QUOTED_STR",
"eap_tls_param : TK_CHUNK_SIZE '=' TK_NUMBER",
"eap_tls_param : TK_RANDOM_FILE '=' TK_UNQUOTED_STR",
"eap_tls_param : TK_RANDOM_FILE '=' TK_QUOTED_STR",
"eap_tls_param : smartcard_section",
"eap_md5_statement : TK_EAP_MD5 '{' eap_md5_params '}'",
"eap_md5_statement : TK_EAP_MD5 '{' '}'",
"eap_md5_params : eap_md5_params eap_md5_param",
"eap_md5_params : eap_md5_param",
"eap_md5_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_md5_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_md5_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_md5_param : TK_PASSWORD '=' TK_PASS",
"eap_md5_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_md5_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_ttls_statement : TK_EAP_TTLS '{' eap_ttls_params '}'",
"eap_ttls_statement : TK_EAP_TTLS '{' '}'",
"eap_ttls_params : eap_ttls_params eap_ttls_param",
"eap_ttls_params : eap_ttls_param",
"eap_ttls_param : TK_USER_CERT '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_USER_CERT '=' TK_QUOTED_STR",
"eap_ttls_param : TK_USER_KEY '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_USER_KEY '=' TK_QUOTED_STR",
"eap_ttls_param : TK_USER_KEY_PASS '=' TK_PASS",
"eap_ttls_param : TK_USER_KEY_PASS '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_USER_KEY_PASS '=' TK_QUOTED_STR",
"eap_ttls_param : TK_ROOT_CERT '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_ROOT_CERT '=' TK_QUOTED_STR",
"eap_ttls_param : TK_ROOT_DIR '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_ROOT_DIR '=' TK_QUOTED_STR",
"eap_ttls_param : TK_CRL_DIR '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_CRL_DIR '=' TK_QUOTED_STR",
"eap_ttls_param : TK_CHUNK_SIZE '=' TK_NUMBER",
"eap_ttls_param : TK_RANDOM_FILE '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_RANDOM_FILE '=' TK_QUOTED_STR",
"eap_ttls_param : TK_SESSION_RESUME '=' TK_YES",
"eap_ttls_param : TK_SESSION_RESUME '=' TK_NO",
"eap_ttls_param : TK_SESSION_RESUME '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_CNCHECK '=' TK_UNQUOTED_STR",
"eap_ttls_param : TK_CNEXACT '=' TK_YES",
"eap_ttls_param : TK_CNEXACT '=' TK_NO",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_PAP",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_CHAP",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_MSCHAP",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_MSCHAPV2",
"eap_ttls_param : TK_PHASE2_TYPE '=' TK_EAP_MD5",
"eap_ttls_param : eap_ttls_phase2_statement",
"eap_ttls_phase2_statement : phase2_pap_statement",
"eap_ttls_phase2_statement : phase2_chap_statement",
"eap_ttls_phase2_statement : phase2_mschap_statement",
"eap_ttls_phase2_statement : phase2_mschapv2_statement",
"eap_ttls_phase2_statement : eap_ttls_phase2_eap_statement",
"phase2_pap_statement : TK_PAP '{' phase2_pap_params '}'",
"phase2_pap_params : phase2_pap_params phase2_pap_param",
"phase2_pap_params : phase2_pap_param",
"phase2_pap_param : TK_USERNAME '=' TK_USERNAME_VAL",
"phase2_pap_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"phase2_pap_param : TK_USERNAME '=' TK_QUOTED_STR",
"phase2_pap_param : TK_PASSWORD '=' TK_PASS",
"phase2_pap_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"phase2_pap_param : TK_PASSWORD '=' TK_QUOTED_STR",
"phase2_chap_statement : TK_CHAP '{' phase2_chap_params '}'",
"phase2_chap_params : phase2_chap_params phase2_chap_param",
"phase2_chap_params : phase2_chap_param",
"phase2_chap_param : TK_USERNAME '=' TK_USERNAME_VAL",
"phase2_chap_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"phase2_chap_param : TK_USERNAME '=' TK_QUOTED_STR",
"phase2_chap_param : TK_PASSWORD '=' TK_PASS",
"phase2_chap_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"phase2_chap_param : TK_PASSWORD '=' TK_QUOTED_STR",
"phase2_mschap_statement : TK_MSCHAP '{' phase2_mschap_params '}'",
"phase2_mschap_params : phase2_mschap_params phase2_mschap_param",
"phase2_mschap_params : phase2_mschap_param",
"phase2_mschap_param : TK_USERNAME '=' TK_USERNAME_VAL",
"phase2_mschap_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"phase2_mschap_param : TK_USERNAME '=' TK_QUOTED_STR",
"phase2_mschap_param : TK_PASSWORD '=' TK_PASS",
"phase2_mschap_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"phase2_mschap_param : TK_PASSWORD '=' TK_QUOTED_STR",
"phase2_mschapv2_statement : TK_MSCHAPV2 '{' phase2_mschapv2_params '}'",
"phase2_mschapv2_params : phase2_mschapv2_params phase2_mschapv2_param",
"phase2_mschapv2_params : phase2_mschapv2_param",
"phase2_mschapv2_param : TK_USERNAME '=' TK_USERNAME_VAL",
"phase2_mschapv2_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"phase2_mschapv2_param : TK_USERNAME '=' TK_QUOTED_STR",
"phase2_mschapv2_param : TK_PASSWORD '=' TK_PASS",
"phase2_mschapv2_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"phase2_mschapv2_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_ttls_phase2_eap_statement : eap_md5_statement",
"eap_leap_statement : TK_EAP_LEAP '{' eap_leap_params '}'",
"eap_leap_statement : TK_EAP_LEAP '{' '}'",
"eap_leap_params : eap_leap_params eap_leap_param",
"eap_leap_params : eap_leap_param",
"eap_leap_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_leap_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_leap_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_leap_param : TK_PASSWORD '=' TK_PASS",
"eap_leap_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_leap_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_mschapv2_statement : TK_EAP_MSCHAPV2 '{' eap_mschapv2_params '}'",
"eap_mschapv2_statement : TK_EAP_MSCHAPV2 '{' '}'",
"eap_mschapv2_params : eap_mschapv2_params eap_mschapv2_param",
"eap_mschapv2_params : eap_mschapv2_param",
"eap_mschapv2_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_mschapv2_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_mschapv2_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_mschapv2_param : TK_PASSWORD '=' TK_PASS",
"eap_mschapv2_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_mschapv2_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_mschapv2_param : TK_MSCHAPV2_HASH_PWD '=' TK_UNQUOTED_STR",
"eap_peap_statement : TK_EAP_PEAP '{' eap_peap_params '}'",
"eap_peap_statement : TK_EAP_PEAP '{' '}'",
"eap_peap_params : eap_peap_params eap_peap_param",
"eap_peap_params : eap_peap_param",
"eap_peap_param : TK_IDENTITY '=' TK_IDENTITY_VAL",
"eap_peap_param : TK_IDENTITY '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_IDENTITY '=' TK_QUOTED_STR",
"eap_peap_param : TK_USER_CERT '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_USER_CERT '=' TK_QUOTED_STR",
"eap_peap_param : TK_USER_KEY '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_USER_KEY '=' TK_QUOTED_STR",
"eap_peap_param : TK_USER_KEY_PASS '=' TK_PASS",
"eap_peap_param : TK_USER_KEY_PASS '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_USER_KEY_PASS '=' TK_QUOTED_STR",
"eap_peap_param : TK_ROOT_CERT '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_ROOT_CERT '=' TK_QUOTED_STR",
"eap_peap_param : TK_ROOT_DIR '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_ROOT_DIR '=' TK_QUOTED_STR",
"eap_peap_param : TK_CRL_DIR '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_CRL_DIR '=' TK_QUOTED_STR",
"eap_peap_param : TK_SESSION_RESUME '=' TK_YES",
"eap_peap_param : TK_SESSION_RESUME '=' TK_NO",
"eap_peap_param : TK_SESSION_RESUME '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_PEAPV1_PROPER_KEYING '=' TK_YES",
"eap_peap_param : TK_PEAPV1_PROPER_KEYING '=' TK_NO",
"eap_peap_param : TK_PEAPV1_PROPER_KEYING '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_INNER_ID '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_INNER_ID '=' TK_QUOTED_STR",
"eap_peap_param : TK_CHUNK_SIZE '=' TK_NUMBER",
"eap_peap_param : TK_CNCHECK '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_CNEXACT '=' TK_YES",
"eap_peap_param : TK_CNEXACT '=' TK_NO",
"eap_peap_param : TK_RANDOM_FILE '=' TK_UNQUOTED_STR",
"eap_peap_param : TK_RANDOM_FILE '=' TK_QUOTED_STR",
"eap_peap_param : TK_IAS_QUIRK '=' TK_YES",
"eap_peap_param : TK_IAS_QUIRK '=' TK_NO",
"eap_peap_param : TK_IAS_QUIRK '=' TK_UNQUOTED_STR",
"eap_peap_param : eap_peap_allow_parameter",
"eap_peap_param : eap_peap_phase2_statement",
"eap_peap_allow_parameter : TK_ALLOW_TYPES '=' TK_ALL",
"eap_peap_allow_parameter : TK_ALLOW_TYPES '=' eap_peap_phase2_type_list",
"eap_peap_phase2_type_list : eap_peap_phase2_type_list ',' eap_peap_phase2_type",
"eap_peap_phase2_type_list : eap_peap_phase2_type",
"eap_peap_phase2_type : TK_EAP_MSCHAPV2",
"eap_peap_phase2_type : TK_EAP_MD5",
"eap_peap_phase2_type : TK_EAP_SIM",
"eap_peap_phase2_type : TK_EAP_OTP",
"eap_peap_phase2_type : TK_EAP_GTC",
"eap_peap_phase2_statement : eap_mschapv2_statement",
"eap_peap_phase2_statement : eap_md5_statement",
"eap_peap_phase2_statement : eap_sim_statement",
"eap_sim_statement : TK_EAP_SIM '{' eap_sim_params '}'",
"eap_sim_statement : TK_EAP_SIM '{' '}'",
"eap_sim_params : eap_sim_params eap_sim_param",
"eap_sim_params : eap_sim_param",
"eap_sim_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_sim_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_sim_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_sim_param : TK_PASSWORD '=' TK_PASS",
"eap_sim_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_sim_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_sim_param : TK_AUTO_REALM '=' TK_YES",
"eap_sim_param : TK_AUTO_REALM '=' TK_NO",
"eap_sim_param : TK_AUTO_REALM '=' TK_UNQUOTED_STR",
"eap_aka_statement : TK_EAP_AKA '{' eap_aka_params '}'",
"eap_aka_statement : TK_EAP_AKA '{' '}'",
"eap_aka_params : eap_aka_params eap_aka_param",
"eap_aka_params : eap_aka_param",
"eap_aka_param : TK_USERNAME '=' TK_USERNAME_VAL",
"eap_aka_param : TK_USERNAME '=' TK_UNQUOTED_STR",
"eap_aka_param : TK_USERNAME '=' TK_QUOTED_STR",
"eap_aka_param : TK_PASSWORD '=' TK_PASS",
"eap_aka_param : TK_PASSWORD '=' TK_UNQUOTED_STR",
"eap_aka_param : TK_PASSWORD '=' TK_QUOTED_STR",
"eap_aka_param : TK_AUTO_REALM '=' TK_YES",
"eap_aka_param : TK_AUTO_REALM '=' TK_NO",
"eap_aka_param : TK_AUTO_REALM '=' TK_UNQUOTED_STR",
"wpa_psk_statement : TK_WPA_PSK '{' wpa_psk_params '}'",
"wpa_psk_statement : TK_WPA_PSK '{' '}'",
"wpa_psk_params : wpa_psk_params wpa_psk_param",
"wpa_psk_params : wpa_psk_param",
"wpa_psk_param : TK_WPA_PSK_KEY '=' TK_UNQUOTED_STR",
"wpa_psk_param : TK_WPA_PSK_KEY '=' TK_QUOTED_STR",
"wpa_psk_param : TK_WPA_PSK_HEX_KEY '=' TK_UNQUOTED_STR",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 382 "config_grammar.y"
{
                     config_info = tmp_config;
                     tmp_config = NULL;
                  }
break;
case 2:
#line 386 "config_grammar.y"
{ 
                      printf("Error: No networks defined.\n"); 
		      CLEAN_EXIT;
		    }
break;
case 3:
#line 390 "config_grammar.y"
{
		      printf("Error: No globals defined.\n"); 
		      cleanup_parse();
		      return XECONFIGPARSEFAIL;
                    }
break;
case 4:
#line 395 "config_grammar.y"
{
		    printf("General Parse error!\n");
 		      cleanup_parse();
		      return XECONFIGPARSEFAIL; }
break;
case 9:
#line 409 "config_grammar.y"
{
                      set_current_globals();
                      parameter_debug("network_list: all\n");
		      /* do nothing. leave null*/
                    }
break;
case 10:
#line 414 "config_grammar.y"
{
		    /* done below. nothing to do here*/
  		    }
break;
case 11:
#line 417 "config_grammar.y"
{
 		     set_current_globals();
		     parameter_debug("Default network: \"%s\"\n", yyvsp[0].str);
		     if (tmp_config->globals->default_net)
		       free(yyvsp[0].str);
		     else
		       tmp_config->globals->default_net = yyvsp[0].str;
		  }
break;
case 12:
#line 425 "config_grammar.y"
{
 		     set_current_globals();
		     parameter_debug("Default network: \"%s\"\n", yyvsp[0].str);
		     if (tmp_config->globals->default_net)
		       free(yyvsp[0].str);
		     else
		       tmp_config->globals->default_net = yyvsp[0].str;
		  }
break;
case 13:
#line 433 "config_grammar.y"
{
		    set_current_globals();
		    parameter_debug("Friendly Warnings: YES\n");
		    UNSET_FLAG(tmp_config->globals->flags, 
			     CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
break;
case 14:
#line 439 "config_grammar.y"
{
		    set_current_globals();
		    parameter_debug("Friendly Warnings: NO\n");
		    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
break;
case 15:
#line 445 "config_grammar.y"
{
		    set_current_globals();
		    printf("Invalid vale for \"friendly_warnings\" option! "
			   "defaulting to YES.\n");
		    parameter_debug("Friendly Warnings: Defaulting to YES"
				    " (Invalid value \"%s\")\n", yyvsp[0].str);
                    UNSET_FLAG(tmp_config->globals->flags,
		             CONFIG_GLOBALS_NO_FRIENDLY_WARNINGS);
                    }
break;
case 16:
#line 454 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Firmware roaming.\n");
                    SET_FLAG(tmp_config->globals->flags, 
			     CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
break;
case 17:
#line 460 "config_grammar.y"
{
                    set_current_globals();      
                    parameter_debug("Xsupplicant roaming.\n");
                    UNSET_FLAG(tmp_config->globals->flags, 
			       CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
break;
case 18:
#line 466 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Xsupplicant roaming.\n");
                    printf("Invalid setting for 'roaming' value.  "
                    	       "Defaulting to Xsupplicant based roaming.\n");
                    UNSET_FLAG(tmp_config->globals->flags, 
			       CONFIG_GLOBALS_FIRMWARE_ROAM);
                    }
break;
case 19:
#line 474 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Passive Scanning : Yes\n");
                    SET_FLAG(tmp_config->globals->flags,
                             CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
break;
case 20:
#line 480 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Passive Scanning : No\n");
                    UNSET_FLAG(tmp_config->globals->flags,
	                       CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
break;
case 21:
#line 486 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Passive Scanning : Yes\n");
                    printf("Invalid setting for 'passive_scanning'."
	                         " Defaulting to yes.\n");
		    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_PASSIVE_SCAN);
                    }
break;
case 22:
#line 494 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Use EAP Hints : Yes\n");
                    UNSET_FLAG(tmp_config->globals->flags,
			       CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
break;
case 23:
#line 500 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Use EAP Hints : No\n");
                    SET_FLAG(tmp_config->globals->flags,
			     CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
break;
case 24:
#line 506 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Use EAP Hints : Yes\n");
                    printf("Invalid setting for 'use_eap_hints'."
	                         " Defaulting to yes.\n");
		    UNSET_FLAG(tmp_config->globals->flags,
			       CONFIG_GLOBALS_NO_EAP_HINTS);
                    }
break;
case 25:
#line 514 "config_grammar.y"
{
                    set_current_globals();
                    parameter_debug("Passive Scan Timer: %d\n", yyvsp[0].num);
                    tmp_config->globals->passive_timeout = yyvsp[0].num;
                    }
break;
case 26:
#line 519 "config_grammar.y"
{
		    set_current_globals();
		    parameter_debug("Scan timeout: %d\n", yyvsp[0].num);
		    tmp_config->globals->active_timeout = yyvsp[0].num;
		  }
break;
case 27:
#line 524 "config_grammar.y"
{
		     set_current_globals();
		     parameter_debug("Logfile: \"%s\"\n", yyvsp[0].str);
		     if (tmp_config->globals->logfile)
		       {
			 free(yyvsp[0].str);
			 tmp_config->globals->logfile = NULL;
		       }
		     else
		       tmp_config->globals->logfile = yyvsp[0].str;
		    }
break;
case 28:
#line 535 "config_grammar.y"
{
		    set_current_globals();
		    parameter_debug("Logfile: \"%s\"\n", yyvsp[0].str);
		    if (tmp_config->globals->logfile)
		      {
			free(yyvsp[0].str);
			tmp_config->globals->logfile = NULL;
		      }
		    else
		      tmp_config->globals->logfile = yyvsp[0].str;
		  }
break;
case 29:
#line 546 "config_grammar.y"
{
		    set_current_globals();
                    parameter_debug("Default Interface: \"%s\"\n", yyvsp[0].str);
		    if (tmp_config->globals->default_int)
		      {
			free(yyvsp[0].str);
			tmp_config->globals->default_int = NULL;
		      }
		    else
		      tmp_config->globals->default_int = yyvsp[0].str;
		    }
break;
case 30:
#line 557 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->stale_key_timeout = yyvsp[0].num;
		    }
break;
case 31:
#line 561 "config_grammar.y"
{
		    set_current_globals();
		    printf("Invalid value for stale key "
				 "timer.  Leaving at the default of 10 minutes"
				 "!\n");
		    }
break;
case 32:
#line 567 "config_grammar.y"
{
                    set_current_globals();
                    SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
break;
case 33:
#line 571 "config_grammar.y"
{
                    set_current_globals();
                    UNSET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
break;
case 34:
#line 575 "config_grammar.y"
{
                    set_current_globals();
                    printf("Invalid setting for 'association'! "
	                         "Leaving at default setting.\n");
                    UNSET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_ASSOC_AUTO);
                  }
break;
case 35:
#line 581 "config_grammar.y"
{
                    set_current_globals();
                    tmp_config->globals->assoc_timeout = yyvsp[0].num;
                  }
break;
case 36:
#line 585 "config_grammar.y"
{
                    set_current_globals();
                    printf("Invalid setting for association_timeout."
	                         " We will use the default setting.\n");
                  }
break;
case 37:
#line 590 "config_grammar.y"
{
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_AUTH_PER)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_AUTH_PER);
		       tmp_config->globals->auth_period = yyvsp[0].num;
		     }
                    }
break;
case 38:
#line 597 "config_grammar.y"
{
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_HELD_PER)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_HELD_PER);
		       tmp_config->globals->held_period = yyvsp[0].num;
		     }
                    }
break;
case 39:
#line 604 "config_grammar.y"
{
		     set_current_globals();
		     if (!TEST_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_MAX_STARTS)) {
		       SET_FLAG(tmp_config->globals->flags, CONFIG_GLOBALS_MAX_STARTS);
		       tmp_config->globals->max_starts = yyvsp[0].num;
		     }
                    }
break;
case 40:
#line 611 "config_grammar.y"
{
		     set_current_globals();
		     SET_FLAG(tmp_config->globals->flags,
			      CONFIG_GLOBALS_ALLMULTI);
                    }
break;
case 41:
#line 616 "config_grammar.y"
{
		     set_current_globals();
		     UNSET_FLAG(tmp_config->globals->flags,
				CONFIG_GLOBALS_ALLMULTI);
                    }
break;
case 42:
#line 621 "config_grammar.y"
{
                     printf("Unknown value for ALLMULTI = \"%s\"! Defaulting to YES! (Line : %d)\n", yyvsp[0].str, config_linenum);
		     set_current_globals();
		     SET_FLAG(tmp_config->globals->flags,
			      CONFIG_GLOBALS_ALLMULTI);
                    }
break;
case 43:
#line 627 "config_grammar.y"
{
		    set_current_globals();
		    if (!tmp_config->globals->ipc_group_name)
			  tmp_config->globals->ipc_group_name = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 44:
#line 634 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->destination = DEST_AUTO;
                      }
break;
case 45:
#line 638 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->destination = DEST_BSSID;
                      }
break;
case 46:
#line 642 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->destination = DEST_MULTICAST;
                      }
break;
case 47:
#line 646 "config_grammar.y"
{
		    set_current_globals();
		    tmp_config->globals->destination = DEST_SOURCE;
                      }
break;
case 48:
#line 650 "config_grammar.y"
{
		    printf("Invalid destination value = \"%s\"!  Defaulting to AUTO! (Line : %d)\n", yyvsp[0].str, config_linenum);
                    set_current_globals();
                    tmp_config->globals->destination = DEST_AUTO;
                      }
break;
case 49:
#line 655 "config_grammar.y"
{
                    set_current_globals();
                    if (!tmp_config->globals->log_facility)
                          tmp_config->globals->log_facility = yyvsp[0].str;
                    else
                      free(yyvsp[0].str);
                    }
break;
case 50:
#line 664 "config_grammar.y"
{
                       parameter_debug("network_list: \"%s\"\n", yyvsp[0].str);
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    yyvsp[0].str))
			 free(yyvsp[0].str);
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     yyvsp[0].str);
                    }
break;
case 51:
#line 674 "config_grammar.y"
{ 
                       parameter_debug("network_list: \"%s\"\n", yyvsp[0].str);
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    yyvsp[0].str))
			 free(yyvsp[0].str);
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     yyvsp[0].str);
                    }
break;
case 52:
#line 684 "config_grammar.y"
{
                       parameter_debug("network_list: \"%s\"\n", yyvsp[0].str);
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    yyvsp[0].str))
			 free(yyvsp[0].str);
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     yyvsp[0].str);
                    }
break;
case 53:
#line 694 "config_grammar.y"
{ 
                       parameter_debug("network_list: \"%s\"\n", yyvsp[0].str);
		       set_current_globals();
		       if (config_string_list_contains_string(tmp_config->globals->allowed_nets,
							    yyvsp[0].str))
			 free(yyvsp[0].str);
		       else 
			 config_string_list_add_string(&tmp_config->globals->allowed_nets,
						     yyvsp[0].str);
                    }
break;
case 54:
#line 706 "config_grammar.y"
{
                      set_current_config();
		      tmp_network->name = yyvsp[-3].str;

		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
break;
case 55:
#line 726 "config_grammar.y"
{
                      set_current_config();

		      tmp_network->name = (char *)malloc(100);
		      sprintf(tmp_network->name, "%d", yyvsp[-3].num);

		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
break;
case 56:
#line 748 "config_grammar.y"
{
		    set_current_config();
		    tmp_network->name = yyvsp[-3].str;

		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
break;
case 57:
#line 768 "config_grammar.y"
{
		    set_current_config();
		      set_current_network();

		      tmp_network->name = yyvsp[-2].str;
		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
                    }
break;
case 58:
#line 789 "config_grammar.y"
{
                      set_current_config();
		      set_current_network();

		      tmp_network->name = yyvsp[-2].str;
		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
break;
case 59:
#line 810 "config_grammar.y"
{
                      set_current_config();
		      set_current_network();

		      tmp_network->name = (char *)malloc(100);
		      sprintf(tmp_network->name, "%d", yyvsp[-2].num);
		      /* check if there is a networks field and that */
		      /* the current tmp is not already listed*/
		      if ((!tmp_config->networks ||
			  !config_network_contains_net(tmp_config->networks,
						       tmp_network->name)) &&
			  config_allows_network(tmp_config, tmp_network->name))
		      {
			config_network_add_net(&(tmp_config->networks),
					       tmp_network);
		      }
		      /* if we don't need it, delete it*/
		      else {
			delete_config_network(&tmp_network);
		      }
		      tmp_network = NULL;
		    }
break;
case 74:
#line 853 "config_grammar.y"
{
                           parameter_debug("Priority : %d\n", yyvsp[0].num);
                           set_current_network();
                           tmp_network->priority = yyvsp[0].num;
                         }
break;
case 75:
#line 860 "config_grammar.y"
{
                           parameter_debug("Type: Wireless\n");
			   set_current_network();
			   if (tmp_network->type == UNSET)
			     tmp_network->type = WIRELESS;
                         }
break;
case 76:
#line 866 "config_grammar.y"
{
                           parameter_debug("Type: Wired\n");
			   set_current_network();
			   if (tmp_network->type == UNSET)
			     tmp_network->type = WIRED;
                         }
break;
case 77:
#line 872 "config_grammar.y"
{
			   set_current_network();
			   tmp_network->type = UNSET;
			   printf("Unknown interface type = \"%s\"!  Defaulting to UNSET! (Line : %d)\n", yyvsp[0].str, config_linenum);
			 }
break;
case 78:
#line 879 "config_grammar.y"
{
                              parameter_debug("WPA Group Crypt : WEP40\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WEP40;
			      }
break;
case 79:
#line 884 "config_grammar.y"
{
			      parameter_debug("WPA Group Crypt : TKIP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_TKIP;
			      }
break;
case 80:
#line 889 "config_grammar.y"
{
			      parameter_debug("WPA Group Crypt : WRAP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WRAP;
			      }
break;
case 81:
#line 894 "config_grammar.y"
{
			      parameter_debug("WPA Group Crypt : CCMP\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_CCMP;
			      }
break;
case 82:
#line 899 "config_grammar.y"
{
			      parameter_debug("WPA Group Crypt : WEP104\n");
			      set_current_network();
			      tmp_network->wpa_group_crypt = CRYPT_WEP104;
			      }
break;
case 83:
#line 906 "config_grammar.y"
{
                                 parameter_debug("WPA Pairwise Crypt : WEP40\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WEP40;
                                 }
break;
case 84:
#line 911 "config_grammar.y"
{
				 parameter_debug("WPA Pairwise Crypt : TKIP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_TKIP;
			         }
break;
case 85:
#line 916 "config_grammar.y"
{
				 parameter_debug("WPA Pairwise Crypt : WRAP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WRAP;
	      		         }
break;
case 86:
#line 921 "config_grammar.y"
{
				 parameter_debug("WPA Pairwise Crypt : CCMP\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_CCMP;
			         }
break;
case 87:
#line 926 "config_grammar.y"
{
				 parameter_debug("WPA Pairwise Crypt : WEP104\n");
				 set_current_network();
				 tmp_network->wpa_pairwise_crypt = CRYPT_WEP104;
			         }
break;
case 88:
#line 933 "config_grammar.y"
{
                           parameter_debug("Force EAPOL Version : %d\n", yyvsp[0].num);
                           set_current_network();
                           tmp_network->force_eapol_ver = yyvsp[0].num;
                         }
break;
case 89:
#line 940 "config_grammar.y"
{
                           parameter_debug("Control Wireless = YES\n");
			   set_current_network();
			   if (tmp_network->wireless_ctrl == CTL_UNSET)
			     tmp_network->wireless_ctrl = CTL_YES;
                         }
break;
case 90:
#line 946 "config_grammar.y"
{
			   parameter_debug("Control Wireless = NO\n");
			   set_current_network();
			   if (tmp_network->wireless_ctrl == CTL_UNSET)
			     tmp_network->wireless_ctrl = CTL_NO;
			 }
break;
case 91:
#line 952 "config_grammar.y"
{
			   set_current_network();
			   tmp_network->wireless_ctrl = CTL_UNSET;
			   printf("Unknown option for Control Wireless = \"%s\"!  Defaulting to UNSET! (Line : %d)\n", yyvsp[0].str, config_linenum);
			 }
break;
case 92:
#line 959 "config_grammar.y"
{
                            parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
                          }
break;
case 93:
#line 967 "config_grammar.y"
{
			    parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
			  }
break;
case 94:
#line 975 "config_grammar.y"
{
			    parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_network();
			    if (!tmp_network->identity)
			      tmp_network->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
			  }
break;
case 95:
#line 985 "config_grammar.y"
{
                          parameter_debug("Use TNC : Yes");
                          set_current_network();
                          SET_FLAG(tmp_network->flags, CONFIG_NET_USE_TNC);
                        }
break;
case 96:
#line 990 "config_grammar.y"
{
                          parameter_debug("Use TNC : No");
                          set_current_network();
                          UNSET_FLAG(tmp_network->flags, CONFIG_NET_USE_TNC);
                        }
break;
case 97:
#line 997 "config_grammar.y"
{
                            parameter_debug("Dest Mac: %s\n", yyvsp[0].str);
			    set_current_network();
			    if (TEST_FLAG(tmp_network->flags, CONFIG_NET_DEST_MAC)) {
			      free(yyvsp[0].str);
			    }
			    else {
			      int tmp_dst_mac[CONFIG_MAC_LEN];
			      int retval;
			      SET_FLAG(tmp_network->flags, CONFIG_NET_DEST_MAC);
			      retval = sscanf(yyvsp[0].str, "%2x:%2x:%2x:%2x:%2x:%2x", 
				     &tmp_dst_mac[0], 
				     &tmp_dst_mac[1], 
				     &tmp_dst_mac[2], 
				     &tmp_dst_mac[3], 
				     &tmp_dst_mac[4], 
				     &tmp_dst_mac[5]);
			      tmp_network->dest_mac[0] = tmp_dst_mac[0];
			      tmp_network->dest_mac[1] = tmp_dst_mac[1];
			      tmp_network->dest_mac[2] = tmp_dst_mac[2];
			      tmp_network->dest_mac[3] = tmp_dst_mac[3];
			      tmp_network->dest_mac[4] = tmp_dst_mac[4];
			      tmp_network->dest_mac[5] = tmp_dst_mac[5];
			    }
                         }
break;
case 98:
#line 1024 "config_grammar.y"
{
                           parameter_debug("Allow Types: ALL\n");
			   set_current_network();
			   SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_ALL);
                       }
break;
case 100:
#line 1032 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_TLS)) {
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_TLS,
					       tmp_tls);
		       }
		       else 
			 delete_config_eap_tls(&tmp_tls);
		       tmp_tls = NULL;
                      }
break;
case 101:
#line 1044 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_MD5))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_MD5,
					       tmp_md5);
		       else 
			 delete_config_eap_md5(&tmp_md5);
		       tmp_md5 = NULL;
                      }
break;
case 102:
#line 1055 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_TTLS))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_TTLS,
					       tmp_ttls);
		       else 
			 delete_config_eap_ttls(&tmp_ttls);
		       tmp_ttls = NULL;
                      }
break;
case 103:
#line 1066 "config_grammar.y"
{
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     STATIC_WEP_METHOD))
			add_config_eap_method(&(tmp_network->methods),
					      STATIC_WEP_METHOD,
					      tmp_static_wep);
		      }
break;
case 104:
#line 1074 "config_grammar.y"
{
		      set_current_network();
                      tmp_network->initial_wep = tmp_initial_wep;
		    }
break;
case 105:
#line 1078 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_LEAP))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_LEAP,
					       tmp_leap);
		       else 
			 delete_config_eap_leap(&tmp_leap);
		       tmp_leap = NULL;
                      }
break;
case 106:
#line 1089 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_MSCHAPV2))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_MSCHAPV2,
					       tmp_mschapv2);
		       else 
			 delete_config_eap_mschapv2(&tmp_mschapv2);
		       tmp_mschapv2 = NULL;
                      }
break;
case 107:
#line 1100 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_PEAP))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_PEAP,
					       tmp_peap);
		       else 
			 delete_config_eap_peap(&tmp_peap);
		       tmp_peap = NULL;
                      }
break;
case 108:
#line 1111 "config_grammar.y"
{
                       set_current_network(); 
		       if (!config_eap_method_contains_method(tmp_network->methods,
							      EAP_TYPE_SIM))
			 add_config_eap_method(&(tmp_network->methods),
					       EAP_TYPE_SIM,
					       tmp_sim);
		       else 
			 delete_config_eap_sim(&tmp_sim);
		       tmp_sim = NULL;
                      }
break;
case 109:
#line 1122 "config_grammar.y"
{
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     EAP_TYPE_AKA))
			add_config_eap_method(&(tmp_network->methods),
					      EAP_TYPE_AKA,
					      tmp_aka);
		      else
			delete_config_eap_aka(&tmp_aka);
		      tmp_aka = NULL;
                      }
break;
case 110:
#line 1133 "config_grammar.y"
{
		      set_current_network();
		      if (!config_eap_method_contains_method(tmp_network->methods,
							     WPA_PSK))
			add_config_eap_method(&(tmp_network->methods),
					      WPA_PSK,
					      tmp_wpa_psk);
		      else
			delete_config_wpa_psk(&tmp_wpa_psk);
		      tmp_wpa_psk = NULL;
                      }
break;
case 113:
#line 1150 "config_grammar.y"
{
                        parameter_debug("Allow Type: TLS\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_TLS);
                      }
break;
case 114:
#line 1155 "config_grammar.y"
{
                        parameter_debug("Allow Type: MD5\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_MD5);
                      }
break;
case 115:
#line 1160 "config_grammar.y"
{
                        parameter_debug("Allow Type: TTLS\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_TTLS);
                      }
break;
case 116:
#line 1165 "config_grammar.y"
{
                        parameter_debug("Allow Type: LEAP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_LEAP);
                      }
break;
case 117:
#line 1170 "config_grammar.y"
{
                        parameter_debug("Allow Type: MSCHAPV2\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_MSCV2);
                      }
break;
case 118:
#line 1175 "config_grammar.y"
{
                        parameter_debug("Allow Type: PEAP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_PEAP);
                      }
break;
case 119:
#line 1180 "config_grammar.y"
{
                        parameter_debug("Allow Type: SIM\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_SIM);
                      }
break;
case 120:
#line 1185 "config_grammar.y"
{
		        parameter_debug("Allow Type: AKA\n");
		        set_current_network();
		        SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_AKA);
		      }
break;
case 121:
#line 1190 "config_grammar.y"
{
                        parameter_debug("Allow Type: GTC\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_GTC);
                      }
break;
case 122:
#line 1195 "config_grammar.y"
{
                        parameter_debug("Allow Type: OTP\n");
			set_current_network();
			SET_FLAG(tmp_network->flags, CONFIG_NET_ALLOW_OTP);
                      }
break;
case 124:
#line 1203 "config_grammar.y"
{
                        set_current_static_wep();  
                      }
break;
case 127:
#line 1212 "config_grammar.y"
{
                        set_current_static_wep();
                        parameter_debug("Static Key 1 : %s\n", yyvsp[0].str);
			if (!tmp_static_wep->key[1])
			  tmp_static_wep->key[1] = (uint8_t *) yyvsp[0].str;
                      }
break;
case 128:
#line 1218 "config_grammar.y"
{
		        set_current_static_wep();
		        parameter_debug("Static Key 2 : %s\n", yyvsp[0].str);
		        if (!tmp_static_wep->key[2])
			  tmp_static_wep->key[2] = (uint8_t *) yyvsp[0].str;
		    }
break;
case 129:
#line 1224 "config_grammar.y"
{
		        set_current_static_wep();
                        parameter_debug("Static Key 3 : %s\n", yyvsp[0].str);
                        if (!tmp_static_wep->key[3])
                          tmp_static_wep->key[3] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 130:
#line 1230 "config_grammar.y"
{
		        set_current_static_wep();
                        parameter_debug("Static Key 4 : %s\n", yyvsp[0].str);
                        if (!tmp_static_wep->key[4])
                          tmp_static_wep->key[4] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 131:
#line 1236 "config_grammar.y"
{
                        set_current_static_wep();
                        parameter_debug("TX Key : %d\n", yyvsp[0].num);
			if ((yyvsp[0].num>4) || (yyvsp[0].num<1))
			  {
			    printf("Static WEP key index is out of range!  It must be a number in the range 1..4!  Defaulting to 1.\n");
			    tmp_static_wep->tx_key = 1;
			  } else {
			    tmp_static_wep->tx_key = yyvsp[0].num;
			  }
                    }
break;
case 133:
#line 1250 "config_grammar.y"
{
                        set_current_initial_wep();
                      }
break;
case 136:
#line 1259 "config_grammar.y"
{
                        set_current_initial_wep();
                        parameter_debug("Initial Key 1 : %s\n", yyvsp[0].str);
			if (!tmp_initial_wep->key[1])
			  tmp_initial_wep->key[1] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 137:
#line 1265 "config_grammar.y"
{
		        set_current_initial_wep();
		        parameter_debug("Initial Key 2 : %s\n", yyvsp[0].str);
		        if (!tmp_initial_wep->key[2])
			  tmp_initial_wep->key[2] = (uint8_t *) yyvsp[0].str;
		    }
break;
case 138:
#line 1271 "config_grammar.y"
{
		        set_current_initial_wep();
                        parameter_debug("Initial Key 3 : %s\n", yyvsp[0].str);
                        if (!tmp_initial_wep->key[3])
                          tmp_initial_wep->key[3] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 139:
#line 1277 "config_grammar.y"
{
		        set_current_initial_wep();
                        parameter_debug("Initial Key 4 : %s\n", yyvsp[0].str);
                        if (!tmp_initial_wep->key[4])
                          tmp_initial_wep->key[4] = (uint8_t *) yyvsp[0].str;
                    }
break;
case 140:
#line 1283 "config_grammar.y"
{
                        set_current_initial_wep();
                        parameter_debug("Initial TX Key : %d\n", yyvsp[0].num);
			if ((yyvsp[0].num>4) || (yyvsp[0].num<1))
			  {
			    printf("Initial WEP key index is out of range!  It must be a number in the range 1..4!  Defaulting to 1.\n");
			    tmp_initial_wep->tx_key = 1;
			  } else {
			    tmp_initial_wep->tx_key = yyvsp[0].num;
                     }
                    }
break;
case 142:
#line 1298 "config_grammar.y"
{
                        set_current_tls(); /* define an empty tls struct*/
                      }
break;
case 145:
#line 1307 "config_grammar.y"
{
		    	set_current_tls();
			parameter_debug("Using Engine: \"%s\"\n", 
						tmp_tls->sc.engine_id);
		      }
break;
case 148:
#line 1319 "config_grammar.y"
{
                        set_current_tls();
			tmp_tls->sc.engine_id = strdup(yyvsp[0].str);
		        parameter_debug("engine: \"%s\"\n", 
						tmp_tls->sc.engine_id);
		      }
break;
case 149:
#line 1325 "config_grammar.y"
{
                        set_current_tls();
			tmp_tls->sc.opensc_so_path = yyvsp[0].str;
                        parameter_debug("opensc_so_path: \"%s\"\n", 
						tmp_tls->sc.opensc_so_path);
                      }
break;
case 150:
#line 1331 "config_grammar.y"
{
		        set_current_tls();
			tmp_tls->sc.opensc_so_path = yyvsp[0].str;
			parameter_debug("opensc_so_path: \"%s\"\n",
					tmp_tls->sc.opensc_so_path);
		    }
break;
case 151:
#line 1337 "config_grammar.y"
{
                        set_current_tls();
			tmp_tls->sc.key_id = yyvsp[0].str;
                        parameter_debug("cert_id: \"%s\"\n", 
						tmp_tls->sc.key_id);
                      }
break;
case 152:
#line 1343 "config_grammar.y"
{
                        set_current_tls();
			tmp_tls->sc.key_id = (char *)malloc(5);
			sprintf(tmp_tls->sc.key_id, "%d", yyvsp[0].num);
                        parameter_debug("cert_id: \"%s\"\n", 
						tmp_tls->sc.key_id);
                      }
break;
case 153:
#line 1352 "config_grammar.y"
{
                        parameter_debug("tls user cert: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_cert)
			  tmp_tls->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 154:
#line 1360 "config_grammar.y"
{
  		        parameter_debug("tls user cert: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_cert)
			  tmp_tls->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 155:
#line 1368 "config_grammar.y"
{
	 	        parameter_debug("tls user key: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key)
			  tmp_tls->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 156:
#line 1376 "config_grammar.y"
{
 		        parameter_debug("tls user key: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key)
			  tmp_tls->user_key = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 157:
#line 1384 "config_grammar.y"
{
	 	        parameter_debug("tls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 158:
#line 1392 "config_grammar.y"
{
		        parameter_debug("tls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 159:
#line 1400 "config_grammar.y"
{
		        parameter_debug("tls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->user_key_pass)
			  tmp_tls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 160:
#line 1408 "config_grammar.y"
{
		        parameter_debug("Session Resumption = YES\n");
		        set_current_tls();
		        if (tmp_tls->session_resume == RES_UNSET)
			  tmp_tls->session_resume = RES_YES;
		      }
break;
case 161:
#line 1414 "config_grammar.y"
{
			parameter_debug("Session Resumption = NO\n");
			set_current_tls();
			if (tmp_tls->session_resume == RES_UNSET)
			  tmp_tls->session_resume = RES_NO;
		      }
break;
case 162:
#line 1420 "config_grammar.y"
{
		      set_current_tls();
		      tmp_tls->session_resume = RES_NO;
		      printf("Invalid value for session resumption = \"%s\"!  Defaulting to NO! (Line : %d)\n", yyvsp[0].str, config_linenum);
		    }
break;
case 163:
#line 1425 "config_grammar.y"
{
	 	        parameter_debug("tls root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->root_cert)
			  tmp_tls->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 164:
#line 1433 "config_grammar.y"
{
		        parameter_debug("tls root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->root_cert)
			  tmp_tls->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 165:
#line 1441 "config_grammar.y"
{
	 	        parameter_debug("tls root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->root_dir)
			  tmp_tls->root_dir = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 166:
#line 1449 "config_grammar.y"
{
		        parameter_debug("tls root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->root_dir)
			  tmp_tls->root_dir = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 167:
#line 1457 "config_grammar.y"
{
	 	        parameter_debug("tls crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->crl_dir)
			  tmp_tls->crl_dir = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 168:
#line 1465 "config_grammar.y"
{
		        parameter_debug("tls crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->crl_dir)
			  tmp_tls->crl_dir = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 169:
#line 1473 "config_grammar.y"
{
 		        parameter_debug("tls chunk: %d\n", yyvsp[0].num);
			set_current_tls();
			if (tmp_tls->chunk_size == 0)
			  tmp_tls->chunk_size = yyvsp[0].num;
  		      }
break;
case 170:
#line 1479 "config_grammar.y"
{
	 	        parameter_debug("tls rand: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->random_file)
			  tmp_tls->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 171:
#line 1487 "config_grammar.y"
{
		        parameter_debug("tls rand: \"%s\"\n", yyvsp[0].str);
			set_current_tls();
			if (!tmp_tls->random_file)
			  tmp_tls->random_file = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		    }
break;
case 174:
#line 1499 "config_grammar.y"
{
                        set_current_md5(); /* define an empty md5 struct*/
                      }
break;
case 177:
#line 1508 "config_grammar.y"
{
                       parameter_debug("md5 username: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 178:
#line 1516 "config_grammar.y"
{
		       parameter_debug("md5 username: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 179:
#line 1524 "config_grammar.y"
{
		       parameter_debug("md5 username: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->username)
			 tmp_md5->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 180:
#line 1532 "config_grammar.y"
{
		       parameter_debug("md5 password: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 181:
#line 1540 "config_grammar.y"
{
		       parameter_debug("md5 password: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 182:
#line 1548 "config_grammar.y"
{
		       parameter_debug("md5 password: \"%s\"\n", yyvsp[0].str);
		       set_current_md5();
		       if (!tmp_md5->password)
			 tmp_md5->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 184:
#line 1559 "config_grammar.y"
{
                        set_current_ttls(); /* define an empty ttls struct*/
                      }
break;
case 187:
#line 1568 "config_grammar.y"
{
                        parameter_debug("ttls user cert: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_cert)
			  tmp_ttls->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 188:
#line 1576 "config_grammar.y"
{
		        parameter_debug("ttls user cert: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_cert)
			  tmp_ttls->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
		      }
break;
case 189:
#line 1584 "config_grammar.y"
{
	 	        parameter_debug("ttls user key: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key)
			  tmp_ttls->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 190:
#line 1592 "config_grammar.y"
{
	 	        parameter_debug("ttls user key: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key)
			  tmp_ttls->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 191:
#line 1600 "config_grammar.y"
{
	 	        parameter_debug("ttls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 192:
#line 1608 "config_grammar.y"
{
	 	        parameter_debug("ttls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 193:
#line 1616 "config_grammar.y"
{
	 	        parameter_debug("ttls user pass: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->user_key_pass)
			  tmp_ttls->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 194:
#line 1624 "config_grammar.y"
{
	 	        parameter_debug("ttls root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->root_cert)
			  tmp_ttls->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 195:
#line 1632 "config_grammar.y"
{
	 	        parameter_debug("ttls root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->root_cert)
			  tmp_ttls->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 196:
#line 1640 "config_grammar.y"
{
	 	        parameter_debug("ttls root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->root_dir)
			  tmp_ttls->root_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 197:
#line 1648 "config_grammar.y"
{
	 	        parameter_debug("ttls root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->root_dir)
			  tmp_ttls->root_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 198:
#line 1656 "config_grammar.y"
{
	 	        parameter_debug("ttls crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->crl_dir)
			  tmp_ttls->crl_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 199:
#line 1664 "config_grammar.y"
{
	 	        parameter_debug("ttls crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->crl_dir)
			  tmp_ttls->crl_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 200:
#line 1672 "config_grammar.y"
{
 		        parameter_debug("ttls chunk: %d\n", yyvsp[0].num);
			set_current_ttls();
			if (tmp_ttls->chunk_size == 0)
			  tmp_ttls->chunk_size = yyvsp[0].num;
  		      }
break;
case 201:
#line 1678 "config_grammar.y"
{
	 	        parameter_debug("ttls rand: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->random_file)
			  tmp_ttls->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 202:
#line 1686 "config_grammar.y"
{
	 	        parameter_debug("ttls rand: \"%s\"\n", yyvsp[0].str);
			set_current_ttls();
			if (!tmp_ttls->random_file)
			  tmp_ttls->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 203:
#line 1694 "config_grammar.y"
{
		        parameter_debug("Session Resumption = YES\n");
		        set_current_ttls();
		        if (tmp_ttls->session_resume == RES_UNSET)
			  tmp_ttls->session_resume = RES_YES;
		      }
break;
case 204:
#line 1700 "config_grammar.y"
{
			parameter_debug("Session Resumption = NO\n");
			set_current_ttls();
			if (tmp_ttls->session_resume == RES_UNSET)
			  tmp_ttls->session_resume = RES_NO;
		      }
break;
case 205:
#line 1706 "config_grammar.y"
{
		      set_current_ttls();
		      tmp_ttls->session_resume = RES_NO;
		      printf("Invalid value for session resume = \"%s\"!  Defaulting to NO!  (Line : %d)\n", yyvsp[0].str, config_linenum);
		    }
break;
case 206:
#line 1711 "config_grammar.y"
{
		        parameter_debug("ttls CN check : \"%s\"\n", yyvsp[0].str);
                        set_current_ttls();
                        if (!tmp_ttls->cncheck)
                          tmp_ttls->cncheck = yyvsp[0].str;
                        else
                          free(yyvsp[0].str);
		      }
break;
case 207:
#line 1719 "config_grammar.y"
{
  		        parameter_debug("match CN exactly : \"yes\"\n");
		        set_current_ttls();
		        tmp_ttls->cnexact = 1;
		    }
break;
case 208:
#line 1724 "config_grammar.y"
{
  		        parameter_debug("match CN exactly : \"no\"\n");
		        set_current_ttls();
		        tmp_ttls->cnexact = 0;
		    }
break;
case 209:
#line 1729 "config_grammar.y"
{
	 	        parameter_debug("ttls phase2_type 'pap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_PAP;
        	      }
break;
case 210:
#line 1739 "config_grammar.y"
{
	 	        parameter_debug("ttls phase2_type 'chap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_CHAP;
        	      }
break;
case 211:
#line 1749 "config_grammar.y"
{
	 	        parameter_debug("ttls phase2_type 'mschap'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_MSCHAP;
        	      }
break;
case 212:
#line 1759 "config_grammar.y"
{
	 	        parameter_debug("ttls phase2_type 'mschapv2'\n");
			if (tmp_ttls && 
			    tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
			  cleanup_parse();
			  return XECONFIGPARSEFAIL;  
			}
			set_current_ttls();
			tmp_ttls->phase2_type = TTLS_PHASE2_MSCHAPV2;
        	      }
break;
case 213:
#line 1769 "config_grammar.y"
{
                        parameter_debug("ttls phase2_type 'eap_md5'\n");
                        if (tmp_ttls &&
                            tmp_ttls->phase2_type != TTLS_PHASE2_UNDEFINED) {
                          cleanup_parse();
                          return XECONFIGPARSEFAIL;
                        }
                        set_current_ttls();
                        tmp_ttls->phase2_type = TTLS_PHASE2_EAP_MD5;
                     }
break;
case 220:
#line 1789 "config_grammar.y"
{
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_PAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_PAP,
						tmp_p2pap);
		       else
			 delete_config_pap(&tmp_p2pap);
		       tmp_p2pap = NULL;
                      }
break;
case 223:
#line 1806 "config_grammar.y"
{
                       parameter_debug("pap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 224:
#line 1814 "config_grammar.y"
{
                       parameter_debug("pap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 225:
#line 1822 "config_grammar.y"
{
                       parameter_debug("pap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->username)
			 tmp_p2pap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 226:
#line 1830 "config_grammar.y"
{
		       parameter_debug("pap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 227:
#line 1838 "config_grammar.y"
{
		       parameter_debug("pap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 228:
#line 1846 "config_grammar.y"
{
		       parameter_debug("pap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2pap();
		       if (!tmp_p2pap->password)
			 tmp_p2pap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 229:
#line 1856 "config_grammar.y"
{
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_CHAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_CHAP,
						tmp_p2chap);
		       else
			 delete_config_chap(&tmp_p2chap);
		       tmp_p2chap = NULL;
                      }
break;
case 232:
#line 1873 "config_grammar.y"
{
                       parameter_debug("chap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 233:
#line 1881 "config_grammar.y"
{
                       parameter_debug("chap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 234:
#line 1889 "config_grammar.y"
{
                       parameter_debug("chap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->username)
			 tmp_p2chap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 235:
#line 1897 "config_grammar.y"
{
		       parameter_debug("chap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 236:
#line 1905 "config_grammar.y"
{
		       parameter_debug("chap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 237:
#line 1913 "config_grammar.y"
{
		       parameter_debug("chap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2chap();
		       if (!tmp_p2chap->password)
			 tmp_p2chap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 238:
#line 1923 "config_grammar.y"
{
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_MSCHAP))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_MSCHAP,
						tmp_p2mschap);
		       else
			 delete_config_mschap(&tmp_p2mschap);
		       tmp_p2mschap = NULL;
                      }
break;
case 241:
#line 1940 "config_grammar.y"
{
                       parameter_debug("mschap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 242:
#line 1948 "config_grammar.y"
{
                       parameter_debug("mschap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 243:
#line 1956 "config_grammar.y"
{
                       parameter_debug("mschap username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->username)
			 tmp_p2mschap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 244:
#line 1964 "config_grammar.y"
{
		       parameter_debug("mschap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 245:
#line 1972 "config_grammar.y"
{
		       parameter_debug("mschap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 246:
#line 1980 "config_grammar.y"
{
		       parameter_debug("mschap password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschap();
		       if (!tmp_p2mschap->password)
			 tmp_p2mschap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 247:
#line 1991 "config_grammar.y"
{
                       set_current_ttls(); 
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
							       TTLS_PHASE2_MSCHAPV2))
			 add_config_ttls_phase2(&(tmp_ttls->phase2), 
						TTLS_PHASE2_MSCHAPV2,
						tmp_p2mschapv2);
		       else
			 delete_config_mschapv2(&tmp_p2mschapv2);
		       tmp_p2mschapv2 = NULL;
                      }
break;
case 250:
#line 2008 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 251:
#line 2016 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 252:
#line 2024 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->username)
			 tmp_p2mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 253:
#line 2032 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 254:
#line 2040 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 255:
#line 2048 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_p2mschapv2();
		       if (!tmp_p2mschapv2->password)
			 tmp_p2mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 256:
#line 2058 "config_grammar.y"
{
		       set_current_ttls();
		       if (!config_ttls_phase2_contains_phase2(tmp_ttls->phase2,
                                                                 TTLS_PHASE2_EAP_MD5))
		         add_config_ttls_phase2(&(tmp_ttls->phase2),
			  	  	        TTLS_PHASE2_EAP_MD5,
					        tmp_md5);
		       else
		         delete_config_eap_md5(&tmp_md5);
		       tmp_p2mschapv2 = NULL;
                     }
break;
case 258:
#line 2072 "config_grammar.y"
{
                        set_current_leap(); /* define an empty leap struct*/
                      }
break;
case 261:
#line 2081 "config_grammar.y"
{
                       parameter_debug("leap username: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 262:
#line 2089 "config_grammar.y"
{
                       parameter_debug("leap username: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 263:
#line 2097 "config_grammar.y"
{
                       parameter_debug("leap username: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->username)
			 tmp_leap->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 264:
#line 2105 "config_grammar.y"
{
		       parameter_debug("leap password: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 265:
#line 2113 "config_grammar.y"
{
		       parameter_debug("leap password: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 266:
#line 2121 "config_grammar.y"
{
		       parameter_debug("leap password: \"%s\"\n", yyvsp[0].str);
		       set_current_leap();
		       if (!tmp_leap->password)
			 tmp_leap->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 268:
#line 2132 "config_grammar.y"
{
                        set_current_mschapv2(); /* define an empty mschapv2 struct*/
                      }
break;
case 271:
#line 2141 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 272:
#line 2149 "config_grammar.y"
{
                       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 273:
#line 2157 "config_grammar.y"
{
		       parameter_debug("mschapv2 username: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->username)
			 tmp_mschapv2->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 274:
#line 2165 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 275:
#line 2173 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 276:
#line 2181 "config_grammar.y"
{
		       parameter_debug("mschapv2 password: \"%s\"\n", yyvsp[0].str);
		       set_current_mschapv2();
		       if (!tmp_mschapv2->password)
			 tmp_mschapv2->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 277:
#line 2189 "config_grammar.y"
{
                       parameter_debug("mschapv2 NT password hash: \"%s\"\n", yyvsp[0].str);
                       set_current_mschapv2();
                       if (!tmp_mschapv2->nthash)
                         tmp_mschapv2->nthash = yyvsp[0].str;
                       else
                         free(yyvsp[0].str);
                     }
break;
case 279:
#line 2200 "config_grammar.y"
{
                        set_current_peap(); /* define an empty peap struct*/
                      }
break;
case 282:
#line 2209 "config_grammar.y"
{
                            parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
                          }
break;
case 283:
#line 2217 "config_grammar.y"
{
                            parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
                          }
break;
case 284:
#line 2225 "config_grammar.y"
{
                            parameter_debug("ID: \"%s\"\n", yyvsp[0].str);
			    set_current_peap();
			    if (!tmp_peap->identity)
			      tmp_peap->identity = yyvsp[0].str;
			    else
			      free(yyvsp[0].str);
                          }
break;
case 285:
#line 2233 "config_grammar.y"
{
                        parameter_debug("peap user cert: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_cert)
			  tmp_peap->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 286:
#line 2241 "config_grammar.y"
{
                        parameter_debug("peap user cert: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_cert)
			  tmp_peap->user_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
                      }
break;
case 287:
#line 2249 "config_grammar.y"
{
	 	        parameter_debug("peap user key: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key)
			  tmp_peap->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 288:
#line 2257 "config_grammar.y"
{
	 	        parameter_debug("peap user key: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key)
			  tmp_peap->user_key = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 289:
#line 2265 "config_grammar.y"
{
	 	        parameter_debug("peap user pass: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 290:
#line 2273 "config_grammar.y"
{
	 	        parameter_debug("peap user pass: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 291:
#line 2281 "config_grammar.y"
{
	 	        parameter_debug("peap user pass: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->user_key_pass)
			  tmp_peap->user_key_pass = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 292:
#line 2289 "config_grammar.y"
{
	 	        parameter_debug("peap root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->root_cert)
			  tmp_peap->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 293:
#line 2297 "config_grammar.y"
{
	 	        parameter_debug("peap root_cert: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->root_cert)
			  tmp_peap->root_cert = yyvsp[0].str;
			else
			  free(yyvsp[0].str);
        	      }
break;
case 294:
#line 2305 "config_grammar.y"
{
	 	        parameter_debug("peap root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->root_dir)
			  tmp_peap->root_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 295:
#line 2313 "config_grammar.y"
{
	 	        parameter_debug("peap root_dir: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->root_dir)
			  tmp_peap->root_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 296:
#line 2321 "config_grammar.y"
{
	 	        parameter_debug("peap crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->crl_dir)
			  tmp_peap->crl_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 297:
#line 2329 "config_grammar.y"
{
	 	        parameter_debug("peap crl_dir: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->crl_dir)
			  tmp_peap->crl_dir = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 298:
#line 2337 "config_grammar.y"
{
		        parameter_debug("Session Resumption = YES\n");
		        set_current_peap();
		        if (tmp_peap->session_resume == RES_UNSET)
			  tmp_peap->session_resume = RES_YES;
		      }
break;
case 299:
#line 2343 "config_grammar.y"
{
			parameter_debug("Session Resumption = NO\n");
			set_current_peap();
			if (tmp_peap->session_resume == RES_UNSET)
			  tmp_peap->session_resume = RES_NO;
		      }
break;
case 300:
#line 2349 "config_grammar.y"
{
		      set_current_peap();
		      tmp_peap->session_resume = RES_NO;
		      printf("Invalid setting for PEAP session resumption = \"%s\"!  Defaulting to NO! (Line : %d)\n", yyvsp[0].str, config_linenum);
		    }
break;
case 301:
#line 2354 "config_grammar.y"
{
		      parameter_debug("Proper PEAPv1 Keying = YES\n");
		      set_current_peap();
		      if (tmp_peap->proper_peapv1 == 0)
			tmp_peap->proper_peapv1 = 1;
		    }
break;
case 302:
#line 2360 "config_grammar.y"
{
		      parameter_debug("Proper PEAPv1 Keying = NO\n");
		      set_current_peap();
		      if (tmp_peap->proper_peapv1 == 1)
			tmp_peap->proper_peapv1 = 0;
		    }
break;
case 303:
#line 2366 "config_grammar.y"
{
		      parameter_debug("Unknown 'Proper PEAPv1 Keying' setting!\n");
		      printf("Unknown value for 'proper_peap_v1_keying'!\n");
		    }
break;
case 304:
#line 2370 "config_grammar.y"
{
                      parameter_debug("inner id : %s\n", yyvsp[0].str);
                      set_current_peap();
                      if (!tmp_peap->identity)
			tmp_peap->identity = yyvsp[0].str;
                    }
break;
case 305:
#line 2376 "config_grammar.y"
{
		      parameter_debug("inner id : %s\n", yyvsp[0].str);
		      set_current_peap();
		      if (!tmp_peap->identity)
			tmp_peap->identity = yyvsp[0].str;
		    }
break;
case 306:
#line 2382 "config_grammar.y"
{
 		        parameter_debug("peap chunk: %d\n", yyvsp[0].num);
			set_current_peap();
			if (tmp_peap->chunk_size == 0)
			  tmp_peap->chunk_size = yyvsp[0].num;
  		      }
break;
case 307:
#line 2388 "config_grammar.y"
{
		        parameter_debug("peap CN check : \"%s\"\n", yyvsp[0].str);
                        set_current_peap();
                        if (!tmp_peap->cncheck)
                          tmp_peap->cncheck = yyvsp[0].str;
                        else
                          free(yyvsp[0].str);
		      }
break;
case 308:
#line 2396 "config_grammar.y"
{
  		        parameter_debug("match CN exactly : \"yes\"\n");
		        set_current_peap();
		        tmp_peap->cnexact = 1;
		    }
break;
case 309:
#line 2401 "config_grammar.y"
{
  		        parameter_debug("match CN exactly : \"no\"\n");
		        set_current_peap();
		        tmp_peap->cnexact = 0;
       		    }
break;
case 310:
#line 2406 "config_grammar.y"
{
	 	        parameter_debug("peap rand: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->random_file)
			  tmp_peap->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 311:
#line 2414 "config_grammar.y"
{
	 	        parameter_debug("peap rand: \"%s\"\n", yyvsp[0].str);
			set_current_peap();
			if (!tmp_peap->random_file)
			  tmp_peap->random_file = yyvsp[0].str;
			else 
			  free(yyvsp[0].str);
        	      }
break;
case 312:
#line 2422 "config_grammar.y"
{
		       parameter_debug("peap ias quirk: YES\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=1;
		     }
break;
case 313:
#line 2427 "config_grammar.y"
{
		       parameter_debug("peap ias quirk: NO\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=0;
		     }
break;
case 314:
#line 2432 "config_grammar.y"
{
		       parameter_debug("peap ias quirk: %s\n", yyvsp[0].str);
		       parameter_debug("Defaulting to NO!\n");
		       set_current_peap();
		       tmp_peap->ias_quirk=0;
		     }
break;
case 315:
#line 2438 "config_grammar.y"
{}
break;
case 316:
#line 2439 "config_grammar.y"
{}
break;
case 317:
#line 2442 "config_grammar.y"
{
                           parameter_debug("PEAP Allow Types: ALL\n");
			   set_current_peap();
			   SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_ALL);
                       }
break;
case 321:
#line 2454 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: MSCHAPV2\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_MSCV2);
                        }
break;
case 322:
#line 2459 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: MD5\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_MD5);
                        }
break;
case 323:
#line 2464 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: SIM\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_SIM);
                        }
break;
case 324:
#line 2469 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: OTP\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_OTP);
                        }
break;
case 325:
#line 2474 "config_grammar.y"
{
                          parameter_debug("PEAP Allow Type: GTC\n");
	  	  	  set_current_peap();
			  SET_FLAG(tmp_peap->flags, CONFIG_PEAP_ALLOW_GTC);
                        }
break;
case 326:
#line 2482 "config_grammar.y"
{
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_MSCHAPV2))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_MSCHAPV2,
						     tmp_mschapv2);

			       /* If we don't have an identity, then copy this*/
			       /* one.*/
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_mschapv2->username);
				 }
			       }
			     else
			       delete_config_eap_mschapv2(&tmp_mschapv2);
			     tmp_mschapv2 = NULL;
                            }
break;
case 327:
#line 2502 "config_grammar.y"
{
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_MD5))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_MD5,
						     tmp_md5);

			       /* If we don't have an identity, then copy this*/
			       /* one.*/
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_md5->username);
				 }
			       }
			     else
			       delete_config_eap_md5(&tmp_md5);
			     tmp_md5 = NULL;
                            }
break;
case 328:
#line 2522 "config_grammar.y"
{
                             set_current_peap(); 
	   	             if (!config_eap_method_contains_method(tmp_peap->phase2,
								    EAP_TYPE_SIM))
			       {
			       add_config_eap_method(&(tmp_peap->phase2),
						     EAP_TYPE_SIM,
						     tmp_sim);
			       
			       /* If we don't have an identity, then copy this*/
			       /* one.*/
			       if (!tmp_peap->identity)
				 {
				   tmp_peap->identity = strdup(tmp_sim->username);
				 }
			       }
			     else
			       delete_config_eap_sim(&tmp_sim);
			     tmp_sim = NULL;
                            }
break;
case 330:
#line 2545 "config_grammar.y"
{
                        set_current_sim(); /* define an empty sim struct*/
                      }
break;
case 333:
#line 2554 "config_grammar.y"
{
                       parameter_debug("sim username: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 334:
#line 2562 "config_grammar.y"
{
                       parameter_debug("sim username: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 335:
#line 2570 "config_grammar.y"
{
                       parameter_debug("sim username: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->username)
			 tmp_sim->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 336:
#line 2578 "config_grammar.y"
{
		       parameter_debug("sim password: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 337:
#line 2586 "config_grammar.y"
{
		       parameter_debug("sim password: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 338:
#line 2594 "config_grammar.y"
{
		       parameter_debug("sim password: \"%s\"\n", yyvsp[0].str);
		       set_current_sim();
		       if (!tmp_sim->password)
			 tmp_sim->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 339:
#line 2602 "config_grammar.y"
{
  		       parameter_debug("sim auto_realm: \"yes\"\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 1;
		   }
break;
case 340:
#line 2607 "config_grammar.y"
{
  		       parameter_debug("sim auto_realm: \"no\"\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 0;
		   }
break;
case 341:
#line 2612 "config_grammar.y"
{
		       parameter_debug("sim auto_realm: \"%s\"\n", yyvsp[0].str);
		       parameter_debug("Defaulting to NO!\n");
		       set_current_sim();
		       tmp_sim->auto_realm = 0;
		   }
break;
case 343:
#line 2620 "config_grammar.y"
{
                        set_current_aka(); /* define an empty aka struct*/
                      }
break;
case 346:
#line 2629 "config_grammar.y"
{
                       parameter_debug("aka username: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 347:
#line 2637 "config_grammar.y"
{
                       parameter_debug("aka username: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 348:
#line 2645 "config_grammar.y"
{
                       parameter_debug("aka username: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->username)
			 tmp_aka->username = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                     }
break;
case 349:
#line 2653 "config_grammar.y"
{
		       parameter_debug("aka password: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 350:
#line 2661 "config_grammar.y"
{
		       parameter_debug("aka password: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 351:
#line 2669 "config_grammar.y"
{
		       parameter_debug("aka password: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       if (!tmp_aka->password)
			 tmp_aka->password = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
		     }
break;
case 352:
#line 2677 "config_grammar.y"
{
  		       parameter_debug("aka auto_realm: \"yes\"\n");
		       set_current_aka();
		       tmp_aka->auto_realm = 1;
		   }
break;
case 353:
#line 2682 "config_grammar.y"
{
  		       parameter_debug("aka auto_realm: \"no\"\n");
		       set_current_aka();
		       tmp_aka->auto_realm = 0;
		   }
break;
case 354:
#line 2687 "config_grammar.y"
{
		       parameter_debug("aka auto_realm: \"%s\"\n", yyvsp[0].str);
		       set_current_aka();
		       tmp_aka->auto_realm = 0;
		   }
break;
case 356:
#line 2694 "config_grammar.y"
{
                       set_current_wpa_psk(); /* define an empty wpa psk struct*/
                   }
break;
case 359:
#line 2703 "config_grammar.y"
{
                       parameter_debug("ascii key : \"%s\"\n", yyvsp[0].str);
                       set_current_wpa_psk();
		       if (!tmp_wpa_psk->key)
			 tmp_wpa_psk->key = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                   }
break;
case 360:
#line 2711 "config_grammar.y"
{
                       parameter_debug("ascii key : \"%s\"\n", yyvsp[0].str);
                       set_current_wpa_psk();
		       if (!tmp_wpa_psk->key)
			 tmp_wpa_psk->key = yyvsp[0].str;
		       else
			 free(yyvsp[0].str);
                   }
break;
case 361:
#line 2719 "config_grammar.y"
{
                       parameter_debug("hex key : \"%s\"\n", yyvsp[0].str);
                       set_current_wpa_psk();
                       if (!tmp_wpa_psk->hex_key)
                         tmp_wpa_psk->hex_key = yyvsp[0].str;
                       else
                         free(yyvsp[0].str);
                   }
break;
#line 4423 "config_grammar.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
